DECLARE SUB delay (aika AS INTEGER)
DECLARE SUB unround (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB button (x%, y%, teksti$, tyyli%)
DECLARE SUB load.world ()
DECLARE SUB save.world ()
DECLARE SUB editworld ()
DECLARE SUB center.loc (x AS INTEGER, y AS INTEGER)
DECLARE SUB draw.world (wx AS INTEGER, wy AS INTEGER)
DECLARE SUB round (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB alarm (text$)
DECLARE SUB mousehide ()
DECLARE SUB mouseshow ()
DECLARE SUB play.random (s AS INTEGER)
DECLARE SUB play.world ()
DECLARE SUB loadpalette (filename$)
DECLARE SUB loadpic (nimi$, address%, offset%)
DECLARE SUB getch ()
DECLARE SUB mousestatus ()
DECLARE SUB MouseDriver (AX%, BX%, CX%, DX%)
DECLARE FUNCTION MouseInit% ()

CONST steplen = 4  'kuinka tihesti pisteit piirretn

CONST world.style.dungeon = 0 'luolasto
CONST world.style.village = 1 'kyl...
CONST world.style.forest = 2 'meht
CONST world.style.hell = 3 'helgutti
CONST world.style.grassland = 4 'ruohomaa

CONST max.x = 40, max.y = 40
DIM SHARED hero.x AS INTEGER, hero.y AS INTEGER, mapx AS INTEGER, mapy AS INTEGER, kx AS INTEGER, ky AS INTEGER
hero.x = 1: hero.y = 1: kx = 1: ky = 1
'kx,y: mit kohti kuljetaan
TYPE world
  sisalto AS INTEGER
  linkki AS INTEGER
END TYPE
DIM SHARED maailma(1 TO max.x, 1 TO max.y) AS world
DIM SHARED filut(1 TO 100) AS STRING * 12'ladattavat maailmat 'luolat+muut

DIM SHARED ylos$, alas$, vasen$, oikea$, ylavasen$, ylaoikea$, alavasen$, alaoikea$
ylavasen$ = CHR$(0) + CHR$(71)
ylos$ = CHR$(0) + CHR$(72)
ylaoikea$ = CHR$(0) + CHR$(73)
vasen$ = CHR$(0) + CHR$(75)
oikea$ = CHR$(0) + CHR$(77)
alavasen$ = CHR$(0) + CHR$(79)
alas$ = CHR$(0) + CHR$(80)
alaoikea$ = CHR$(0) + CHR$(81)

CONST MOUSE.LEFT = 1
CONST MOUSE.RIGHT = 2
DIM SHARED mouse$, mouse.x AS INTEGER, mouse.y AS INTEGER, mouse.button AS INTEGER

'Tll luetaan nppimist
DIM SHARED key$, delay.time AS INTEGER

RESTORE 'Ladataan hiiri
mouse$ = SPACE$(57)
FOR I% = 1 TO 57
  READ a$
  h$ = CHR$(VAL("&H" + a$))
  MID$(mouse$, I%, 1) = h$
NEXT I%

ms% = MouseInit%
IF NOT ms% THEN
  PRINT "Mouse not found... Game won't run. Press a key..."
  getch ' odotetaan
  END
END IF

DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

OPEN "data.dat" FOR BINARY AS #1
  GET #1, , delay.time
CLOSE #1

loadpalette "forest.bmp"

CONST maata = 0, metsaa = 1, kallio = 2, tieta = 3, vetta = 4, kaupunki = 5, luola = 6

DIM SHARED maapic(1 TO 38) AS INTEGER
DIM SHARED metsapic(1 TO 38) AS INTEGER
DIM SHARED vuoripic(1 TO 38) AS INTEGER
DIM SHARED tiepic(1 TO 38) AS INTEGER
DIM SHARED vesipic(1 TO 38) AS INTEGER
DIM SHARED kaupunkipic(1 TO 38) AS INTEGER
DIM SHARED luolapic(1 TO 38) AS INTEGER
DIM SHARED heropic(1 TO 38) AS INTEGER

loadpic "umap.pic", VARSEG(maapic(1)), VARPTR(maapic(1))
loadpic "umount.pic", VARSEG(vuoripic(1)), VARPTR(vuoripic(1))
loadpic "utree.pic", VARSEG(metsapic(1)), VARPTR(metsapic(1))
loadpic "uroad.pic", VARSEG(tiepic(1)), VARPTR(tiepic(1))
loadpic "uwater.pic", VARSEG(vesipic(1)), VARPTR(vesipic(1))
loadpic "ucity.pic", VARSEG(kaupunkipic(1)), VARPTR(kaupunkipic(1))
loadpic "ucave.pic", VARSEG(luolapic(1)), VARPTR(luolapic(1))
loadpic "uhero.pic", VARSEG(heropic(1)), VARPTR(heropic(1))

CALL mouseshow

CALL load.world
'CALL editworld

CALL play.world

SUB alarm (text$)
  CALL mousehide
  CALL round(6, 79, 300, 9)
  LINE (7, 80)-(306, 88), 0, BF
  LOCATE 11, 2: PRINT text$
  getch
  key$ = ""
  CALL mouseshow
END SUB

SUB button (x%, y%, teksti$, tyyli%)
  x1% = (x% - 1) * 8: y1% = (y% - 1) * 8
  LOCATE y%, x%: PRINT teksti$
  IF tyyli% = 1 THEN CALL round(x1%, y1% - 1, LEN(teksti$) * 8, 9) ELSE CALL unround(x1%, y1% - 1, LEN(teksti$) * 8, 9)
END SUB

SUB center.loc (x AS INTEGER, y AS INTEGER)
  mapx = x - 10: mapy = y - 7
  IF mapx < 0 THEN mapx = 0
  IF mapy < 0 THEN mapy = 0
  IF mapx > max.x - 20 THEN mapx = max.x - 20
  IF mapy > max.y - 14 THEN mapy = max.y - 14

END SUB

SUB delay (aika AS INTEGER)
  FOR a% = 1 TO aika
    FOR B& = 1 TO delay.time
    NEXT
  NEXT
END SUB

SUB draw.world (wx AS INTEGER, wy AS INTEGER)
CALL mousehide
FOR x% = 1 TO 20
FOR y% = 1 TO 14
  SELECT CASE maailma(x% + mapx, y% + mapy).sisalto
    CASE 0: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), maapic, PSET
    CASE 1: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), metsapic, PSET
    CASE 2: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), vuoripic, PSET
    CASE 3: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), tiepic, PSET
    CASE 4: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), vesipic, PSET
    CASE 5: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), kaupunkipic, PSET
    CASE 6: PUT ((x% - 1) * 8 + wx, (y% - 1) * 8 + wy), luolapic, PSET
  END SELECT
  IF x% + mapx = hero.x AND y% + mapy = hero.y THEN LINE ((x% - 1) * 8, (y% - 1) * 8)-((x% - 1) * 8 + 7, (y% - 1) * 8 + 7), 14, B
NEXT y%, x%
CALL mouseshow
END SUB

SUB editworld
  DO
    CALL mousehide
    c% = 0
    FOR x% = 1 TO max.x
    FOR y% = 1 TO max.y
      SELECT CASE maailma(x%, y%).sisalto
        CASE maata: c% = 56
        CASE metsaa: c% = 50
        CASE kallio: c% = 20
        CASE tie: c% = 85
        CASE kaupunki: c% = 70
        CASE luola: c% = 27
      END SELECT
      LINE ((x% - 1) * 2, (y% - 1) * 2)-((x% - 1) * 2 + 1, (y% - 1) * 2 + 1), c%, BF
    NEXT y%, x%
    CALL mouseshow
    CALL getch
    IF MID$(key$, 1, 1) = "M" AND LEN(key$) > 1 THEN
      IF ASC(MID$(key$, 2, 1)) = 1 THEN
        IF mouse.x / 2 < max.x * 2 AND mouse.y < max.y * 2 THEN
          maailma(INT(mouse.x / 4) + 1, INT(mouse.y / 2) + 1).sisalto = metsaa
        ELSE
        END IF
      ELSE
      END IF
    END IF
    IF key$ = CHR$(27) THEN
      EXIT DO
    END IF
  LOOP
  key$ = ""
END SUB

SUB getch
  key$ = ""
  c% = 0
  DO
    key$ = INKEY$
    CALL mousestatus
    IF mouse.button <> 0 THEN c% = mouse.button
    IF mouse.button = 0 AND c% <> 0 THEN
      key$ = "M" + CHR$(c%)
    END IF
    IF key$ <> "" OR (hero.x <> kx OR hero.y <> ky) THEN EXIT DO
  LOOP
END SUB

SUB load.world
OPEN "world.dat" FOR BINARY AS #1
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    GET #1, , maailma(x%, y%).sisalto
    GET #1, , maailma(x%, y%).linkki
  NEXT y%, x%
  FOR x% = 1 TO 100
    GET #1, , filut(x%)
  NEXT x%
  GET #1, , mapx
  GET #1, , mapy
  GET #1, , hero.x
  GET #1, , hero.y
CLOSE #1
 kx = hero.x: ky = hero.y
END SUB

SUB loadpalette (filename$)
'bittikartan lataaja - piirt mokoman - (c) Tarmo Korpela

OPEN filename$ FOR BINARY AS #1

header$ = SPACE$(14)
sizing$ = SPACE$(4)
GET #1, 1, header$ 'headeri
GET #1, 15, sizing$ 'kokoluokittelu
bmpinfosize = CVI(sizing$) 'paljonko infoa
IF bmpinfosize = 12 THEN '12 tavua
   infoheader$ = SPACE$(12)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))

   IF nbits = 1 THEN       '1-vrinen
      palet$ = SPACE$(6)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN   '16 vri
      palet$ = SPACE$(48)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN   '256
      palet$ = SPACE$(768)
      GET #1, bmpinfosize + 15, palet$
   END IF
ELSEIF bmpinfosize = 40 THEN '40 tavua
   infoheader$ = SPACE$(40)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))
   IF nbits = 1 THEN   '1-vrinen
      palet$ = SPACE$(8)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN  '16
      palet$ = SPACE$(64)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN  '256
      palet$ = SPACE$(1024)
      GET #1, bmpinfosize + 15, palet$
   END IF
END IF


ft$ = MID$(header$, 1, 2)

filesize = CVL(MID$(header$, 3, 4)) 'tiedoston koko

r1 = CVI(MID$(header$, 7, 2))

r2 = CVI(MID$(header$, 9, 2))

offset = CVL(MID$(header$, 11, 4))


headersize = CVL(MID$(infoheader$, 1, 4))

picwidth = CVL(MID$(infoheader$, 5, 4))

picheight = CVL(MID$(infoheader$, 9, 4))

nplanes = CVI(MID$(infoheader$, 13, 4))


IF headersize = 40 THEN
   comptype = CVL(MID$(infoheader$, 17, 4))

   imagesize = CVL(MID$(infoheader$, 21, 4))

   xsize = CVL(MID$(infoheader$, 25, 4))

   ysize = CVL(MID$(infoheader$, 29, 4))

   colorsused = CVL(MID$(infoheader$, 33, 4))

   neededcolours = CVL(MID$(infoheader$, 37, 4))
END IF

IF nbits = 1 THEN
   SCREEN 11
ELSEIF nbits = 4 THEN
   SCREEN 12
ELSEIF nbits = 8 OR nbits = 24 THEN
   SCREEN 13
END IF

IF bmpinfosize = 40 THEN ngroups = 4
IF bmpinfosize = 12 THEN ngroups = 3

IF nbits = 24 THEN
   IF ngroups = 3 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d)
      NEXT c
   ELSEIF ngroups = 4 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d) + CHR$(0)
      NEXT c
   END IF
END IF

FOR x = 1 TO LEN(palet$) STEP ngroups
   zb# = INT((ASC(MID$(palet$, x, 1))) / 4)
   zg# = INT((ASC(MID$(palet$, x + 1, 1))) / 4)
   zr# = INT((ASC(MID$(palet$, x + 2, 1))) / 4)
   zc# = zb# * 65536# + zg# * 256# + zr#
   cres = ASC(MID$(palet$, x + 3, 1))
   PALETTE ((x - 1) / ngroups), zc#
NEXT x

CLOSE #1

END SUB

SUB loadpic (nimi$, address%, offset%)
  DEF SEG = address%
  BLOAD nimi$, offset%
END SUB

SUB MouseDriver (AX%, BX%, CX%, DX%)
  DEF SEG = VARSEG(mouse$)
  mouse% = SADD(mouse$)
  CALL Absolute(AX%, BX%, CX%, DX%, mouse%)
END SUB

SUB mousehide
 AX% = 2
 MouseDriver AX%, 0, 0, 0
END SUB

FUNCTION MouseInit%
  AX% = 0
  MouseDriver AX%, 0, 0, 0
  MouseInit% = AX%
END FUNCTION

SUB MousePut (x%, y%)
  AX% = 4
  CX% = x%
  DX% = y%
  MouseDriver AX%, 0, CX%, DX%
END SUB

SUB mouseshow
  AX% = 1
  MouseDriver AX%, 0, 0, 0
END SUB

SUB mousestatus
  AX% = 3
  MouseDriver AX%, BX%, CX%, DX%
  mouse.button = BX%
  mouse.x = CX%
  mouse.y = DX%
END SUB

SUB play.random (s AS INTEGER)
  OPEN "map.dat" FOR OUTPUT AS #1
  SELECT CASE s
    CASE maata: PRINT #1, world.style.grassland
    CASE metsaa: PRINT #1, world.style.forest
    CASE luola: PRINT #1, world.style.dungeon
  END SELECT
 
  PRINT #1, 3 'pelaajia

  SELECT CASE s
    CASE maata: PRINT #1, INT(RND * 2)
    CASE metsaa: PRINT #1, INT(RND * 2)
    CASE luola: PRINT #1, 1 + 2 + (INT(RND * 2) * 4)'viholliset & raput yls, sattumalta mys ehk portaat syvemms
  END SELECT
  PRINT #1, "main.bas"
  'muodostetaan koordinaateista nimi
  IF hero.x < 10 THEN coord$ = "0" + RTRIM$(LTRIM$(STR$(hero.x))) ELSE coord$ = RTRIM$(LTRIM$(STR$(hero.x)))
  IF hero.y < 10 THEN coord$ = coord$ + "0" + RTRIM$(LTRIM$(STR$(hero.y))) ELSE coord$ = coord$ + RTRIM$(LTRIM$(STR$(hero.y)))
  coord$ = coord$ + "01" 'eka maanalainen
  SELECT CASE s
    CASE maata: PRINT #1, "map.map"
    CASE metsaa: PRINT #1, "map.map"
    CASE luola: PRINT #1, "D" + coord$ + ".map"
  END SELECT
  CLOSE #1
  CALL save.world
  RUN "crfield.bas"
END SUB

SUB play.world
  button 22, 2, "    Enter area    ", 1
  x2! = 0: y2! = 0 'nill lasketaan fallout-tyyppinen liikkuminen
  DO
    center.loc hero.x, hero.y
    CALL draw.world(0, 0)
    delay 20
    LOCATE 16, 1
    SELECT CASE maailma(hero.x, hero.y).sisalto
      CASE 0: PRINT "Grass        "
      CASE 1: PRINT "Forest       "
      CASE 2: PRINT "Mountains    "
      CASE 3: PRINT "Road         "
      CASE 4: PRINT "Water        "
      CASE 5: PRINT "City:        "
      CASE 6: PRINT "Cave entrance"
    END SELECT
   
    IF key$ = "" THEN getch  'napin tai hiiren painallus
   
    IF LEFT$(key$, 1) = "M" AND LEN(key$) <> 1 THEN 'hiiri
      IF ASC(MID$(key$, 2, 1)) = 1 THEN
        IF mouse.y < 112 THEN
          IF mouse.x / 2 < 160 THEN
            kx = INT(mouse.x / 16) + 1 + mapx
            ky = INT(mouse.y / 8) + 1 + mapy
            IF kx = hero.x AND ky = hero.y THEN key$ = CHR$(13)
          ELSE

          END IF
        ELSE

        END IF
      END IF
    END IF
    IF key$ = CHR$(27) THEN
      EXIT DO
    ELSEIF key$ = CHR$(13) THEN
      IF maailma(hero.x, hero.y).linkki = 0 THEN
        CALL play.random(maailma(hero.x, hero.y).sisalto)
      ELSE
        'load
      END IF
    ELSEIF key$ = ylaoikea$ OR key$ = "9" THEN
      kx = hero.x + 1
      ky = hero.y - 1
    ELSEIF key$ = ylavasen$ OR key$ = "7" THEN
      kx = hero.x - 1
      ky = hero.y - 1
    ELSEIF key$ = alavasen$ OR key$ = "1" THEN
      kx = hero.x - 1
      ky = hero.y + 1
    ELSEIF key$ = alaoikea$ OR key$ = "3" THEN
      kx = hero.x + 1
      ky = hero.y + 1
    ELSEIF key$ = oikea$ OR key$ = "6" THEN
      kx = hero.x + 1
    ELSEIF key$ = vasen$ OR key$ = "4" THEN
      kx = hero.x - 1
    ELSEIF key$ = alas$ OR key$ = "2" THEN
      ky = hero.y + 1
    ELSEIF key$ = ylos$ OR key$ = "8" THEN
      ky = hero.y - 1
    END IF
    key$ = ""
    IF kx < 1 OR kx > max.x THEN kx = hero.x
    IF ky < 1 OR ky > max.y THEN ky = hero.y
    'siirrytn
    x2! = 0: y2! = 0: st% = 0
    IF hero.x = kx OR hero.y = ky THEN
      IF hero.x = kx THEN
        IF hero.y < ky THEN y2! = 1 ELSE y2! = -1
        st% = ABS(ky - hero.y)
      ELSE
        IF hero.x < kx THEN x2! = 1 ELSE x2! = -1
        st% = ABS(kx - hero.x)
      END IF
    ELSEIF ABS(hero.x - kx) <= ABS(hero.y - ky) THEN 'x:n muutos pienempi - xm alle 1
      x2! = (kx - hero.x) / ABS(ky - hero.y)
      IF ky - hero.y < 0 THEN y2! = -1 ELSE y2! = 1
      st% = ABS(ky - hero.y)
    ELSE
      y2! = (ky - hero.y) / ABS(kx - hero.x)
      IF kx - hero.x < 0 THEN x2! = -1 ELSE x2! = 1
      st% = ABS(kx - hero.x)
    END IF
    CALL mousehide
    LINE ((kx - mapx - 1) * 8, (ky - mapy - 1) * 8)-((kx - mapx - 1) * 8 + 7, (ky - mapy - 1) * 8 + 7), 14
    LINE ((kx - mapx - 1) * 8, (ky - mapy - 1) * 8 + 7)-((kx - mapx - 1) * 8 + 7, (ky - mapy - 1) * 8), 14
    x2! = x2! / steplen: y2! = y2! / steplen: st% = st% * steplen
    FOR a% = 1 TO st%  'thn for:iin vlikohtaukset
      PSET (INT((hero.x - mapx - 1 + (a% * x2!)) * 8) + 4, INT((hero.y - mapy - 1 + (a% * y2!)) * 8) + 4), 14
      SOUND 100, .1
      CALL delay(50)
      IF hero.x + INT(a% * x2!) < 1 OR hero.y + INT(a% * y2!) < 1 THEN EXIT FOR
      IF INT(RND * 50) = 1 AND maailma(hero.x + INT(a% * x2!), hero.y + INT(a% * y2!)).sisalto < kaupunki THEN  'vlikohtaus
        FOR w% = 0 TO 7
          PSET (INT((hero.x - mapx - 1 + (a% * x2!)) * 8) + w%, INT((hero.y - mapy - 1 + (a% * y2!)) * 8) + w%), 14
          PSET (INT((hero.x - mapx - 1 + (a% * x2!)) * 8) + 7 - w%, INT((hero.y - mapy - 1 + (a% * y2!)) * 8) + w%), 14
          SOUND 500, .1
          delay 100
        NEXT w%
        kx = hero.x + INT(a% * x2!): ky = hero.y + INT(a% * y2!)
        key$ = CHR$(13)
        EXIT FOR
      END IF
      'CIRCLE (INT((hero.x - mapx - 1 + (a% * x2!)) * 8) + 4, INT((hero.y - mapy - 1 + (a% * y2!)) * 8) + 4), 2, 2
    NEXT a%
    CALL mouseshow
    hero.x = kx: hero.y = ky
  LOOP
 
  SYSTEM

END SUB

SUB round (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
  FOR a% = 0 TO 3
    LINE (x - a%, y - a%)-(x + w + a%, y + h + a%), 16 + (a% * 4), B
  NEXT a%
END SUB

SUB save.world
OPEN "world.dat" FOR BINARY AS #1
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    PUT #1, , maailma(x%, y%).sisalto
    PUT #1, , maailma(x%, y%).linkki
  NEXT y%, x%
  FOR x% = 1 TO 100
    PUT #1, , filut(x%)
  NEXT x%
  PUT #1, , mapx
  PUT #1, , mapy
  PUT #1, , hero.x
  PUT #1, , hero.y
CLOSE #1
END SUB

SUB unround (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
  FOR a% = 0 TO 3
    LINE (x - a%, y - a%)-(x + w + a%, y + h + a%), 31 - (a% * 3), B
  NEXT a%
END SUB

