DECLARE SUB enter.dungeon (mista AS INTEGER)
DECLARE SUB exit.dungeon ()
DECLARE SUB save.map ()
DECLARE FUNCTION onkoeste% (x AS INTEGER, y AS INTEGER, fly AS INTEGER)
DECLARE SUB loadmap ()
DECLARE SUB aimed.attack (kuka AS INTEGER, mita AS INTEGER)
DECLARE SUB cast.spell (x AS INTEGER, y AS INTEGER, kx AS INTEGER, ky AS INTEGER, sp AS INTEGER)
DECLARE SUB determine.player.pic (kuka AS INTEGER)
DECLARE SUB h.inventory ()
DECLARE SUB add.item.map (x AS INTEGER, y AS INTEGER, it AS INTEGER)
DECLARE SUB pick.up (kuka AS INTEGER, x AS INTEGER, y AS INTEGER)
DECLARE SUB handle.map.area (x AS INTEGER, y AS INTEGER)
DECLARE SUB loadpic (nimi$, address%, offset%)
DECLARE SUB alarm (text$)
DECLARE FUNCTION count.damage% (dam$)
DECLARE SUB save.values ()
DECLARE SUB load.values ()
DECLARE SUB upgr.panel ()
DECLARE SUB reg.heroes ()
DECLARE SUB draw.creature (x AS INTEGER, y AS INTEGER, mika AS INTEGER)
DECLARE SUB attack.to (kuka AS INTEGER, kehen AS INTEGER)
DECLARE SUB center.location (x AS INTEGER, y AS INTEGER)
DECLARE SUB alusta.hirviot ()
DECLARE SUB monster.move ()
DECLARE FUNCTION closest.hero% (x AS INTEGER, y AS INTEGER)
DECLARE FUNCTION hero.range% (x AS INTEGER, y AS INTEGER)
DECLARE SUB handle.map ()
DECLARE SUB draw.panel ()
DECLARE SUB items ()
DECLARE FUNCTION last.item% (pala AS ANY)
DECLARE SUB pyyhi.nappain ()
DECLARE SUB movehero (kuka AS INTEGER)
DECLARE SUB move.hero (kuka AS INTEGER, xm%, ym%)
DECLARE FUNCTION vastasuunta% (s AS INTEGER)
DECLARE FUNCTION suuntabyxm% (xm AS INTEGER, ym AS INTEGER)
DECLARE SUB getch ()
DECLARE SUB MouseDriver (AX%, BX%, CX%, DX%)
DECLARE FUNCTION MouseInit% ()
DECLARE SUB identify.block (pala AS ANY)
DECLARE FUNCTION floor.round% (x AS SINGLE)
DECLARE SUB mousestatus ()
DECLARE SUB round (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB see.area (x AS INTEGER, y AS INTEGER, r AS INTEGER)
DECLARE SUB delay (aika AS INTEGER)
DECLARE SUB mousehide ()
DECLARE SUB mouseshow ()
DECLARE SUB minimap ()
DECLARE SUB load.bmp (filename$, drawit AS INTEGER)
DECLARE SUB draw.map ()
DECLARE SUB initgraph ()

'QWORLD (c) Tarmo Korpela 2003-2010


CONST max.monsters = 50 'montako monsua max. / kartta
CONST max.items = 100 'montako esinett max. / kartta. (ei sisll varastoja!)
CONST MAX.WEAPONS = 50 'montako erilaista asetta
CONST MAX.BOOK = 15 'montako erilaista kirjaa
CONST MAX.BOTTLES = 5 'montako erilaista juomaa
CONST MAX.ARMOR = 8 'montako erilaista panssaria
CONST MAX.HELMET = 8 'montako erilaista kypr
CONST MAX.SHIELD = 8 'montako erilaista kilpe
CONST MAX.PLAYER = 5 'max. pelaajia mukana
CONST MAX.H.TYPE = 5 'max. hirvityyppi / kentt
CONST max.x = 80 'Kartan koko
CONST max.y = 30 '
CONST max.item.carry = 12 'montako esinett max. kannossa

CONST world.style.dungeon = 0 'luolasto
CONST world.style.village = 1 'kyl...
CONST world.style.forest = 2 'meht
CONST world.style.hell = 3 'helgari
CONST world.style.grassland = 4

DIM SHARED worldstyle AS INTEGER, mapx AS INTEGER, mapy AS INTEGER
DIM SHARED delay.time AS LONG, komennot AS INTEGER
DIM SHARED pelaajia AS INTEGER, LEADER AS INTEGER

LEADER = 1

DIM SHARED ylos$, alas$, vasen$, oikea$, ylavasen$, ylaoikea$, alavasen$, alaoikea$
ylavasen$ = CHR$(0) + CHR$(71)
ylos$ = CHR$(0) + CHR$(72)
ylaoikea$ = CHR$(0) + CHR$(73)
vasen$ = CHR$(0) + CHR$(75)
oikea$ = CHR$(0) + CHR$(77)
alavasen$ = CHR$(0) + CHR$(79)
alas$ = CHR$(0) + CHR$(80)
alaoikea$ = CHR$(0) + CHR$(81)

'Karttaluokka
CONST NAKYY = 1 'dataan

CONST OBJ.MAA = 0
  CONST OBJ.MAA.TUNNELI = 0
  CONST OBJ.MAA.LATTIA = 1

CONST obj.este = 1
  CONST OBJ.ESTE.MUURI = 0
  CONST OBJ.ESTE.VETTA = 1

CONST OBJ.OVI = 2
  CONST obj.ovi.auki = 0
  CONST OBJ.OVI.KIINNI = 1
  CONST OBJ.OVI.LUKITTU = 2
  CONST OBJ.OVI.SALA = 3

CONST OBJ.KASVI = 3
  CONST OBJ.KASVI.TUTKIMATON = 0
  CONST OBJ.KASVI.TUTKITTU = 1

CONST OBJ.PORTAAT = 4
  CONST OBJ.PORTAAT.YLOS = 0
  CONST OBJ.PORTAAT.ALAS = 1

TYPE MAP
  dat AS INTEGER
  yleisobj AS INTEGER 'katso yll
  erikobj AS INTEGER  'erikoistuotanto
  itemlink AS INTEGER 'alkulinkki esineeseen - 0=ei esinett
  oliolink AS INTEGER 'linkki elolliseen olioon - 0=ei oliota, -1 = pelaaja
END TYPE
DIM SHARED kartta(1 TO max.x, 1 TO max.y) AS MAP, kkerros AS INTEGER
'kkerros = mill tasolla mennn maan alla

CONST esine.ase = 0
CONST esine.kirja = 1
CONST esine.juoma = 2
CONST esine.panssari = 3
CONST esine.kilpi = 4
CONST esine.kypara = 5

TYPE ITEM
  tyyppi AS INTEGER 'mik luokka?
  linkki AS INTEGER 'linkki tyypin mrittelemn esineeseen
  ketju AS INTEGER 'linkki seuraavaan esineeseen
END TYPE
DIM SHARED esineet(1 TO max.items)  AS ITEM

TYPE WEAPON 'aseluokka
  nimi AS STRING * 20
  hrange AS INTEGER 'miten kaukaa ly? ruoskilla 2...3, jousilla 1-->99
  pisteet AS INTEGER 'montako ac:ta kuluttaa?
  damage AS STRING * 6
END TYPE
DIM SHARED aseluokat(0 TO MAX.WEAPONS) AS WEAPON

TYPE ARMOR 'suojaluokka
  nimi AS STRING * 20
  pisteet AS INTEGER 'kuinka iso suoja
END TYPE
DIM SHARED suojaluokat(0 TO MAX.ARMOR) AS ARMOR

TYPE HELMET 'suojaluokka
  nimi AS STRING * 20
  pisteet AS INTEGER 'kuinka iso suoja
END TYPE
DIM SHARED kyparaluokat(0 TO MAX.HELMET) AS HELMET

TYPE SHIELD 'suojaluokka
  nimi AS STRING * 20
  pisteet AS INTEGER 'kuinka iso suoja
END TYPE
DIM SHARED kilpiluokat(0 TO MAX.SHIELD) AS SHIELD

TYPE DRINKING
  nimi AS STRING * 20
  mita AS INTEGER 'mit antaa / tekee
END TYPE
DIM SHARED potions(1 TO MAX.BOTTLES) AS DRINKING

'itse asiaas loitsu eik kirja
TYPE BOOK
  nimi AS STRING * 20
  dam AS STRING * 6
END TYPE
DIM SHARED kirjaluokat(1 TO MAX.BOOK) AS BOOK

CALL items     'luodaan esineet

TYPE MONSTERMAIN 'hirvin ptyyppi
  nimi AS STRING * 20
  file AS STRING * 20 'kuvatiedosto
  elomax AS INTEGER 'kuinka paljon elm (max)
  range AS INTEGER 'kuinka pitkn matkan pst hirvi alkaa tulemaan kohti
  steps AS INTEGER 'kuinka monta askelta hirvi liikkuu / vuoro?
  spec AS INTEGER  'speciaalikyky
  pase AS INTEGER
END TYPE
DIM SHARED hirvioluokka(1 TO MAX.H.TYPE) AS MONSTERMAIN

TYPE monster 'linkkihirvi
  tyyppi AS INTEGER 'linkki phirveln
  x AS INTEGER
  y AS INTEGER
  elo AS INTEGER 'paljonko elm
  ls AS INTEGER
  onoff AS INTEGER 'onko kytss
  ase AS INTEGER
END TYPE
DIM SHARED hirviot(1 TO max.monsters) AS monster, NUMOFM AS INTEGER

CONST rotu.ihminen = 0, rotu.haltia = 1, rotu.m.haltia = 2, rotu.kaapio = 3, rotu.orkki = 4
CONST luokka.maagi = 0, luokka.barbaari = 1, luokka.jousiampuja = 2

TYPE heroclass
  rotu AS INTEGER
  luokka AS INTEGER
  acpoints AS INTEGER 'toimintapisteet
  acpmax AS INTEGER 'maximi
  nimi AS STRING * 20
  elo AS INTEGER
  elomax AS INTEGER
  mana AS INTEGER
  manax AS INTEGER
 
  ase AS INTEGER 'mik ase?
  kilpi AS INTEGER ' - "" -
  kypara AS INTEGER ' - "" -
  armori AS INTEGER 'mik panssari

  loitsu AS INTEGER  'mik loitsu kytss. 0=ei loitsua

  x AS INTEGER 'nyk. sijainti
  y AS INTEGER '
  kx AS INTEGER 'kohde-pos
  ky AS INTEGER '
  ls AS INTEGER
END TYPE
CONST itemtype = 1, itemlink = 2
DIM SHARED sankarit(1 TO MAX.PLAYER) AS heroclass, inventory(1 TO MAX.PLAYER, 1 TO max.item.carry, 1 TO 2) AS INTEGER
'hahmojen osaamat loitsut. 0=ei osaa, 0> taso
DIM SHARED loitsut(1 TO MAX.PLAYER, 1 TO MAX.BOOK) AS INTEGER

'Grafiikan talletusta, olennot
DIM SHARED heropic1(1 TO 202) AS INTEGER    'sankarin kuva
DIM SHARED heropic2(1 TO 202) AS INTEGER    'sankarin kuva
DIM SHARED heropic3(1 TO 202) AS INTEGER    'sankarin kuva
DIM SHARED heropic4(1 TO 202) AS INTEGER    'sankarin kuva
DIM SHARED heropic5(1 TO 202) AS INTEGER    'sankarin kuva
'viholliset
DIM SHARED enemypic1(1 TO 202) AS INTEGER
DIM SHARED enemypic2(1 TO 202) AS INTEGER
DIM SHARED enemypic3(1 TO 202) AS INTEGER
DIM SHARED enemypic4(1 TO 202) AS INTEGER
DIM SHARED enemypic5(1 TO 202) AS INTEGER
' ja maapaloja (yksilkohtaiset / maailma
DIM SHARED groundpic(1 TO 202) AS INTEGER 'Tavallista maata
DIM SHARED roompic(1 TO 202) AS INTEGER   'Huoneen lattiaa
DIM SHARED wallpic(1 TO 202) AS INTEGER   'muuria
DIM SHARED plantpic(1 TO 202) AS INTEGER 'kasvi
DIM SHARED swaypic(1 TO 202) AS INTEGER  'rappuset
DIM SHARED doorpic(1 TO 202) AS INTEGER  'drren
' Ja lis! Yleismaailmallisia
DIM SHARED heappic(1 TO 202) AS INTEGER   'Kasa kaikkea
DIM SHARED bookpic(1 TO 202) AS INTEGER   'kirja = loitsu
DIM SHARED weaponpic(1 TO 202) AS INTEGER 'joku ase
DIM SHARED armorpic(1 TO 202) AS INTEGER  'varuste
DIM SHARED bottlepic(1 TO 202) AS INTEGER 'Buteli
'DIM SHARED GOLDPIC(1 TO 202) AS INTEGER   'Kultaa!!

'Hiiren tekniset tiedot
CONST MOUSE.LEFT = 1
CONST MOUSE.RIGHT = 2
DIM SHARED mouse$, mouse.x AS INTEGER, mouse.y AS INTEGER, mouse.button AS INTEGER

DIM SHARED ylos.file AS STRING * 12 'minne mennn rappusista
DIM SHARED alas.file AS STRING * 12
DIM SHARED curr.file AS STRING * 12 'mik kartta nyt menossa

'kartalle
DIM SHARED MAP.X AS INTEGER, MAP.Y AS INTEGER
MAP.X = 0: MAP.Y = 0


'Tll luetaan nppimist
DIM SHARED Key$

RESTORE 'Ladataan hiiri
mouse$ = SPACE$(57)
FOR I% = 1 TO 57
  READ a$
  h$ = CHR$(VAL("&H" + a$))
  MID$(mouse$, I%, 1) = h$
NEXT I%

ms% = MouseInit%
IF NOT ms% THEN
  PRINT "Mouse not found... Game won't run. Press a key..."
  getch ' odotetaan
  END
END IF

DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

OPEN "data.dat" FOR BINARY AS #1
  GET #1, , delay.time
CLOSE #1



RANDOMIZE TIMER
CALL loadmap
CALL center.location(sankarit(1).x, sankarit(1).y)
CALL draw.panel
CALL mouseshow
xm% = 0: ym% = 0
lmouse% = 0

DO 'universal main mega loop


DO
  CALL handle.map: FOR a% = 1 TO pelaajia: CALL see.area(sankarit(a%).x, sankarit(a%).y, 5): NEXT
  CALL center.location(sankarit(LEADER).x, sankarit(LEADER).y)
  CALL mousehide
  CALL draw.map
  CALL upgr.panel
  CALL mouseshow
  Key$ = ""
  DO WHILE Key$ = ""
    Key$ = INKEY$
    CALL mousestatus
    IF mouse.button = 0 AND lmouse% = -1 THEN
      lmouse% = 0
      IF mouse.y < 160 THEN
        xm% = INT(mouse.x / 40) + 1 + mapx: ym% = INT(mouse.y / 20) + 1 + mapy
        IF NOT onkoeste(xm%, ym%, 0) AND kartta(xm%, ym%).dat <> 0 THEN
          sankarit(LEADER).kx = xm%
          sankarit(LEADER).ky = ym%
          sankarit(LEADER).ls = -1
          IF sankarit(LEADER).kx = sankarit(LEADER).x AND sankarit(LEADER).ky = sankarit(LEADER).y THEN
            CALL handle.map.area(xm%, ym%)
          END IF
        ELSEIF kartta(xm%, ym%).dat <> 0 THEN
          CALL handle.map.area(xm%, ym%)
        END IF
        EXIT DO
      ELSE 'hiiri nostettu paneelin pll
        IF mouse.x / 2 <= (pelaajia - 1) * 23 + 23 THEN 'klikattu hamopaneelia
          LEADER = INT(mouse.x / 47) + 1
          CALL draw.panel
          CALL center.location(sankarit(LEADER).x, sankarit(LEADER).y)
          CALL mousehide: CALL draw.map: CALL mouseshow
          'EXIT DO
        'klikattu komentopaneelia
        ELSEIF mouse.x / 2 > 120 AND mouse.x / 2 < 200 THEN
          xm% = INT(((mouse.x / 2) - 120) / 20)
          SELECT CASE xm%
            CASE 0: Key$ = "i"
            CASE 1: Key$ = "z"
            CASE 2: Key$ = "d"
            CASE 3: Key$ = "t"
          END SELECT
          CALL mousehide
          CALL draw.map
          CALL mouseshow
        ELSEIF mouse.x / 2 > 300 THEN
          Key$ = "v": EXIT DO 'vuoro vaihtuu...
        END IF
      END IF
    END IF
    IF (mouse.button AND 1) THEN
      lmouse% = -1
    END IF
    IF (mouse.button AND 2) THEN
      IF mouse.y < 160 THEN
        CALL mousehide
        CALL identify.block(kartta(INT(mouse.x / 40) + 1 + mapx, INT(mouse.y / 20) + 1 + mapy))
        CALL draw.map
        CALL mouseshow
      ELSE
        IF mouse.x / 2 <= (pelaajia - 1) * 23 + 23 THEN 'klikattu hamopaneelia
          CALL mousehide
          CALL identify.block(kartta(sankarit(INT(mouse.x / 47) + 1).x, sankarit(INT(mouse.x / 47) + 1).y))
          CALL draw.map
          CALL mouseshow
        END IF
      END IF
    END IF
    IF (sankarit(LEADER).kx <> sankarit(LEADER).x OR sankarit(LEADER).ky <> sankarit(LEADER).y) AND sankarit(LEADER).acpoints > 0 THEN
      CALL movehero(LEADER)
      EXIT DO
    END IF
  LOOP
  CALL delay(10)
  SELECT CASE Key$
    CASE CHR$(27), "v": EXIT DO
    CASE "n":
      LEADER = LEADER + 1
      IF LEADER > pelaajia THEN LEADER = 1
      CALL draw.panel
    CASE CHR$(9): CALL minimap
    CASE ylavasen$, "7"
      sankarit(LEADER).kx = sankarit(LEADER).x - 1
      sankarit(LEADER).ky = sankarit(LEADER).y - 1
    CASE ylaoikea$, "9"
      sankarit(LEADER).kx = sankarit(LEADER).x + 1
      sankarit(LEADER).ky = sankarit(LEADER).y - 1
    CASE alavasen$, "1"
      sankarit(LEADER).kx = sankarit(LEADER).x - 1
      sankarit(LEADER).ky = sankarit(LEADER).y + 1
    CASE alaoikea$, "3"
      sankarit(LEADER).kx = sankarit(LEADER).x + 1
      sankarit(LEADER).ky = sankarit(LEADER).y + 1
    CASE ylos$, "8"
      sankarit(LEADER).ky = sankarit(LEADER).y - 1
    CASE vasen$, "4"
      sankarit(LEADER).kx = sankarit(LEADER).x - 1
    CASE oikea$, "6"
      sankarit(LEADER).kx = sankarit(LEADER).x + 1
    CASE alas$, "2"
      sankarit(LEADER).ky = sankarit(LEADER).y + 1
    CASE CHR$(13):
      handle.map.area sankarit(LEADER).x, sankarit(LEADER).y
    CASE ",":
      CALL pick.up(LEADER, sankarit(LEADER).x, sankarit(LEADER).y)
    CASE "t":
      aimed.attack LEADER, 0
    CASE "z":
      aimed.attack LEADER, 1
    CASE "i":
      CALL h.inventory
  END SELECT
LOOP
  IF Key$ = CHR$(27) THEN EXIT DO
  CALL reg.heroes
  CALL monster.move
LOOP

SYSTEM

SUB add.item.map (x AS INTEGER, y AS INTEGER, it AS INTEGER)
  IF kartta(x, y).itemlink = 0 THEN
    kartta(x, y).itemlink = it
  ELSE
    esineet(last.item(kartta(x, y))).ketju = it
  END IF
END SUB

'ammutaan nuolia / isketn loitsuilla
SUB aimed.attack (kuka AS INTEGER, mita AS INTEGER)
  handle.map
  IF sankarit(kuka).loitsu = 0 AND mita = 1 THEN mita = -1: alarm "Learn a spell first!"
  IF (sankarit(kuka).acpoints >= aseluokat(sankarit(kuka).ase).pisteet AND mita = 0) OR mita = 1 THEN
    see.area sankarit(kuka).x, sankarit(kuka).y, 5
    IF mita = 0 THEN r% = aseluokat(sankarit(kuka).ase).hrange ELSE r% = 5
    eka% = 0
    kehen% = 1
    DO
      upgr.panel
      vih% = 0: kkehen% = 1
      FOR x1% = sankarit(kuka).x - r% TO sankarit(kuka).x + r%
      FOR y1% = sankarit(kuka).y - r% TO sankarit(kuka).y + r%
        IF x1% > 0 AND y1% > 0 AND x1% <= max.x AND y1% <= max.y THEN
          IF kartta(x1%, y1%).oliolink > 0 AND kartta(x1%, y1%).dat = 1 THEN
            vih% = vih% + 1
            IF vih% = 1 THEN eka% = kartta(x1%, y1%).oliolink
            IF vih% = kehen% THEN kkehen% = kartta(x1%, y1%).oliolink: EXIT FOR
          END IF
        END IF
      NEXT y1%
      IF vih% = kehen% THEN EXIT FOR
      NEXT x1%
      IF vih% <> kehen% THEN kehen% = 1: kkehen% = eka%
      IF vih% = 0 THEN EXIT DO
      Key$ = ""
      IF ABS(hirviot(kkehen%).x - sankarit(kuka).x) > ABS(hirviot(kkehen%).y - sankarit(kuka).y) THEN hite% = ABS(hirviot(kkehen%).x - sankarit(kuka).x) ELSE hite% = ABS(hirviot(kkehen%).y - sankarit(kuka).y)
      CALL mousehide
      IF hite% >= 5 THEN CALL center.location(hirviot(kkehen%).x, hirviot(kkehen%).y) ELSE CALL center.location(sankarit(kuka).x, sankarit(kuka).y)
      draw.map
      'LINE ((hirviot(kkehen%).x - mapx - 1) * 20 + 9, (hirviot(kkehen%).y - mapy - 1) * 20 + 9)-((sankarit(kuka).x - mapx - 1) * 20 + 9, (sankarit(kuka).y - mapy - 1) * 20 + 9), 26
      CIRCLE ((hirviot(kkehen%).x - mapx - 1) * 20 + 9, (hirviot(kkehen%).y - mapy - 1) * 20 + 9), 2, 12
      CIRCLE ((hirviot(kkehen%).x - mapx - 1) * 20 + 9, (hirviot(kkehen%).y - mapy - 1) * 20 + 9), 6, 14
      CIRCLE ((hirviot(kkehen%).x - mapx - 1) * 20 + 9, (hirviot(kkehen%).y - mapy - 1) * 20 + 9), 10, 153
      IF mita = 1 THEN LOCATE 1, 1: PRINT "Spell: "; kirjaluokat(sankarit(kuka).loitsu).nimi; ",D="; kirjaluokat(sankarit(kuka).loitsu).dam: PRINT "(C)hange spell"
      CALL mouseshow
      c% = 0
      DO
        Key$ = INKEY$
        IF Key$ <> "" THEN EXIT DO
        CALL mousestatus
        IF mouse.button <> 0 THEN c% = mouse.button
        IF mouse.button = 0 AND c% <> 0 THEN EXIT DO
      LOOP
      IF c% = 1 THEN 'klikattu
        x1% = INT(mouse.x / 40) + 1 + mapx
        y1% = INT(mouse.y / 20) + 1 + mapy
        IF kartta(x1%, y1%).oliolink > 0 AND mita = 0 THEN
          kkehen% = kartta(x1%, y1%).oliolink: Key$ = "t"
        ELSEIF mita = 1 THEN
          CALL cast.spell(sankarit(kuka).x, sankarit(kuka).y, x1%, y1%, sankarit(kuka).loitsu)
        END IF
      ELSEIF c% = 2 THEN
        Key$ = CHR$(27)
      END IF
      IF Key$ = "t" AND mita = 0 THEN
        attack.to -kuka, kkehen%
        sankarit(kuka).acpoints = sankarit(kuka).acpoints - aseluokat(sankarit(kuka).ase).pisteet
        IF kkehen% <> 0 THEN
          IF aseluokat(hirviot(kkehen%).tyyppi).hrange >= hite% THEN attack.to kkehen%, -kuka
        END IF
        'EXIT DO
      ELSEIF Key$ = "z" AND mita = 1 THEN 'loitsua
        CALL cast.spell(sankarit(kuka).x, sankarit(kuka).y, hirviot(kkehen%).x, hirviot(kkehen%).y, sankarit(kuka).loitsu)
      ELSEIF Key$ = "n" THEN
        kehen% = kehen% + 1
      ELSEIF Key$ = CHR$(27) THEN
        EXIT DO
      END IF
    LOOP
  END IF
END SUB

SUB alarm (text$)
  CALL mousehide
  CALL round(6, 79, 300, 9)
  LINE (7, 80)-(306, 88), 0, BF
  LOCATE 11, 2: PRINT text$
  getch
  'key$ = ""
  CALL mouseshow
END SUB

SUB alusta.hirviot
  file$ = SPACE$(20)
  OPEN "enemy.dat" FOR BINARY AS #1
    FOR a% = 1 TO MAX.H.TYPE
      GET #1, , hirvioluokka(a%).nimi
      GET #1, , file$
      GET #1, , hirvioluokka(a%).elomax
      GET #1, , hirvioluokka(a%).range
      GET #1, , hirvioluokka(a%).steps
      GET #1, , hirvioluokka(a%).pase
      GET #1, , hirvioluokka(a%).spec
      SELECT CASE a%
'        CASE 1: loadpic file$, VARSEG(enemypic1(1)), VARPTR(enemypic1(1))
'        CASE 2: loadpic file$, VARSEG(enemypic2(1)), VARPTR(enemypic2(1))
'        CASE 3: loadpic file$, VARSEG(enemypic3(1)), VARPTR(enemypic3(1))
'        CASE 4: loadpic file$, VARSEG(enemypic4(1)), VARPTR(enemypic4(1))
'        CASE 5: loadpic file$, VARSEG(enemypic5(1)), VARPTR(enemypic5(1))
      END SELECT
    NEXT a%
  CLOSE #1
END SUB

SUB attack.to (kuka AS INTEGER, kehen AS INTEGER)
  dam% = 0: mihin% = 0: tor% = 0
    'efekti ni
      SOUND 200, .1
    'efekti end
  IF kuka < 0 THEN 'sankari hykk!
    CALL center.location(sankarit(ABS(kuka)).x, sankarit(ABS(kuka)).y)
    CALL draw.map
      'lyntiefekti
      LINE ((sankarit(ABS(kuka)).x - mapx - 1) * 20 + 9, (sankarit(ABS(kuka)).y - mapy - 1) * 20 + 9)-((hirviot(kehen).x - mapx - 1) * 20 + 9, (hirviot(kehen).y - mapy - 1) * 20 + 9), 26
      CIRCLE ((hirviot(kehen).x - mapx - 1) * 20 + 9, (hirviot(kehen).y - mapy - 1) * 20 + 9), 5, 14
    hirviot(kehen).elo = hirviot(kehen).elo - count.damage(aseluokat(sankarit(ABS(kuka)).ase).damage)
    IF hirviot(kehen).elo <= 0 THEN
      hirviot(kehen).onoff = (1 = 0)
      'hahmon nollaus kartalta
      IF hirviot(kehen).ase > 0 AND INT(RND * 20) = 0 THEN 'ase j
        FOR a% = 1 TO max.items
          IF esineet(a%).tyyppi = -1 THEN 'tm on pois plt
            esineet(a%).tyyppi = esine.ase
            esineet(a%).linkki = hirviot(kehen).ase
            CALL add.item.map(hirviot(kehen).x, hirviot(kehen).y, a%)
            EXIT FOR
          END IF
        NEXT a%
      END IF
      kartta(hirviot(kehen).x, hirviot(kehen).y).oliolink = 0
      kehen = 0
    END IF
    'hykkys pysytt
    sankarit(ABS(kuka)).kx = sankarit(ABS(kuka)).x: sankarit(ABS(kuka)).ky = sankarit(ABS(kuka)).y
  ELSEIF kehen < 0 THEN
    CALL center.location(sankarit(ABS(kehen)).x, sankarit(ABS(kehen)).y)
    CALL draw.map
      LINE ((hirviot(kuka).x - mapx - 1) * 20 + 9, (hirviot(kuka).y - mapy - 1) * 20 + 9)-((sankarit(ABS(kehen)).x - mapx - 1) * 20 + 9, (sankarit(ABS(kehen)).y - mapy - 1) * 20 + 9), 26
      CIRCLE ((sankarit(ABS(kehen)).x - mapx - 1) * 20 + 9, (sankarit(ABS(kehen)).y - mapy - 1) * 20 + 9), 5, 14
      mihin% = INT(RND * 3) 'torso,p,kdet
      dam% = count.damage(aseluokat(hirviot(kuka).ase).damage)
      IF mihin% = 0 THEN
        tor% = kilpiluokat(sankarit(ABS(kehen)).kilpi).pisteet
        'kilpi voi blokata (rnd * 20 = 0...0,12...20)
        IF RND * 20 < tor% THEN dam% = 0 ELSE dam% = dam% - tor%
      ELSEIF mihin% = 1 THEN
        tor% = kyparaluokat(sankarit(ABS(kehen)).kypara).pisteet
        dam% = INT(dam% * 2)   'p on arempi paikka
        dam% = dam% - tor%
      ELSE
        tor% = suojaluokat(sankarit(ABS(kehen)).armori).pisteet
        dam% = dam% - tor%
      END IF
      IF dam% < 1 THEN 'tystorjunta, ni & efekti
        dam% = 0
        FOR a% = 1 TO 10
          CIRCLE ((sankarit(ABS(kehen)).x - mapx - 1) * 20 + 9, (sankarit(ABS(kehen)).y - mapy - 1) * 20 + 9), a%, 20 + a%
          SOUND 2000 - a% * 50, .05 'pop
        NEXT
      END IF
    'ja lasketaan damage
    sankarit(ABS(kehen)).elo = sankarit(ABS(kehen)).elo - dam%
  END IF
  CALL delay(100)
END SUB

SUB cast.spell (x AS INTEGER, y AS INTEGER, kx AS INTEGER, ky AS INTEGER, sp AS INTEGER)
  DIM osuneet(1 TO 10) AS INTEGER, dam(1 TO 10)  AS INTEGER
  FOR a% = 1 TO 10: osuneet(a%) = 0: dam(a%) = 0: NEXT
  xm1! = 0: ym1! = 0
  IF x = kx OR y = ky THEN
    IF x = kx THEN
      IF y < ky THEN ym1! = 1 ELSE ym1! = -1
    ELSE
      IF x < kx THEN xm1! = 1 ELSE xm1! = -1
    END IF
  ELSEIF ABS(x - kx) <= ABS(y - ky) THEN 'x:n muutos pienempi - xm alle 1
    xm1! = (kx - x) / ABS(ky - y)
    IF ky - y < 0 THEN ym1! = -1 ELSE ym1! = 1
  ELSE
    ym1! = (ky - y) / ABS(kx - x)
    IF kx - x < 0 THEN xm1! = -1 ELSE xm1! = 1
  END IF 'nyt on xm ja ym - menee suoraan kohteeseen viivana ilman mutkia
  x1! = x + .5: y1! = y + .5
  SELECT CASE sp
    CASE 1: 'tulibolt
      FOR a% = 1 TO 5 '5=max range
        x1! = x1! + xm1!: y1! = y1! + ym1!
        IF onkoeste(INT(x1!), INT(y1!), 1) THEN EXIT FOR
        center.location INT(x1!), INT(y1!)
        draw.map
        FOR c% = 1 TO 5
          CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), c% + 1, 65 + c%
        NEXT c%
        SOUND 100, .05: SOUND 150, .05 'steppi
        delay 100
        IF kartta(INT(x1!), INT(y1!)).oliolink <> 0 THEN 'osuma
          osuneet(1) = kartta(INT(x1!), INT(y1!)).oliolink
          dam(1) = count.damage(kirjaluokat(sp).dam) 'damage
          EXIT FOR
        END IF
      NEXT
      FOR c% = 6 TO 10: CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), c% + 1, 65 + c%: SOUND 200 + c% * 20, .1: NEXT c%
      delay 100
    CASE 2: 'salamointi
      a% = 0
      lx% = (x - mapx) * 20 - 11: ly% = (y - mapy) * 20 - 11
      wx% = 0: wy% = 0
      CALL mousehide
      FOR a% = 1 TO 6
        x1! = x1! + xm1!: y1! = y1! + ym1!
        IF INT(x1!) < 1 OR INT(x1!) > max.x OR INT(y1!) < 1 OR INT(y1!) > max.y THEN EXIT FOR
        IF (kartta(INT(x1!), INT(y1!)).yleisobj = obj.este AND kartta(INT(x1!), INT(y1!)).erikobj = OBJ.ESTE.MUURI) OR (kartta(INT(x1!), INT(y1!)).yleisobj = OBJ.OVI AND kartta(INT(x1!), INT(y1!)).erikobj <> obj.ovi.auki) THEN EXIT FOR
        IF onkoeste(INT(x1!), INT(y1!), 1) THEN EXIT FOR
        wx% = (INT(x1!) - mapx) * 20 - 11: wy% = (INT(y1!) - mapy) * 20 - 11
        IF ly% < 160 AND wy% < 160 THEN
          LINE (lx%, ly%)-(wx% - 5 + INT(RND * 11), wy% - 5 + INT(RND * 11)), 15
          LINE (lx%, ly%)-(wx% - 5 + INT(RND * 11), wy% - 5 + INT(RND * 11)), 15
        END IF
        lx% = wx%: ly% = wy%
        IF kartta(INT(x1!), INT(y1!)).oliolink <> 0 THEN 'osuma
          IF ABS(x - INT(x1!)) > 8 OR ABS(y - INT(y1!)) > 3 THEN center.location INT(x1!), INT(y1!): draw.map: delay 200
          FOR c% = 1 TO 9: CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), c%, 15: NEXT c%
          osuneet(a%) = kartta(INT(x1!), INT(y1!)).oliolink
          dam(a%) = count.damage("1d8+0") 'damage
        END IF
        delay 100
      NEXT
      CALL mouseshow
    CASE 3: 'poison!
      FOR a% = 1 TO 5 'max range
        x1! = x1! + xm1!: y1! = y1! + ym1!
        IF onkoeste(INT(x1!), INT(y1!), 1) THEN EXIT FOR
        CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), 3, 55
        CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), 4, 10
        delay 100
        IF kartta(INT(x1!), INT(y1!)).oliolink <> 0 THEN 'osuma
          center.location INT(x1!), INT(y1!)
          draw.map
          'plurts-efekti
          FOR c% = 1 TO 10
            CIRCLE ((INT(x1!) - mapx) * 20 - 19 + INT(RND * 20), ((INT(y1!) - mapy) * 20 - 19 + INT(RND * 20))), 3, 55
            CIRCLE ((INT(x1!) - mapx) * 20 - 19 + INT(RND * 20), ((INT(y1!) - mapy) * 20 - 19 + INT(RND * 20))), 3, 60
            delay 50
            SOUND 100 + INT(RND * 100), .05
          NEXT c%
          osuneet(1) = kartta(INT(x1!), INT(y1!)).oliolink
          dam(1) = count.damage(kirjaluokat(sp).dam) 'damage
          EXIT FOR
        END IF
      NEXT
      FOR c% = 6 TO 10: CIRCLE ((INT(x1!) - mapx) * 20 - 11, ((INT(y1!) - mapy) * 20 - 11)), c% + 1, 55 + c%: SOUND 200 + c% * 20, .1: NEXT c%
  END SELECT
  FOR a% = 1 TO 10
    IF osuneet(a%) <> 0 THEN
      IF osuneet(a%) < 0 THEN
        osuneet(a%) = ABS(osuneet(a%))
        sankarit(osuneet(a%)).elo = sankarit(osuneet(a%)).elo - dam(a%)
        IF sankarit(osuneet(a%)).elo < 1 THEN kartta(sankarit(osuneet(a%)).x, sankarit(osuneet(a%)).y).oliolink = 0
      ELSE
        hirviot(osuneet(a%)).elo = hirviot(osuneet(a%)).elo - dam(a%)
        IF hirviot(osuneet(a%)).elo < 1 THEN hirviot(osuneet(a%)).onoff = (1 = 0): kartta(hirviot(osuneet(a%)).x, hirviot(osuneet(a%)).y).oliolink = 0
      END IF
    END IF
  NEXT
END SUB

SUB center.location (x AS INTEGER, y AS INTEGER)
  mapx = x - 8: mapy = y - 4
  IF mapx < 0 THEN mapx = 0
  IF mapx > max.x - 16 THEN mapx = max.x - 16
  IF mapy < 0 THEN mapy = 0
  IF mapy > max.y - 8 THEN mapy = max.y - 8
END SUB

FUNCTION closest.hero% (x AS INTEGER, y AS INTEGER)
  r% = 100: w% = 1
  FOR a% = 1 TO pelaajia
    IF ABS(x - sankarit(a%).x) >= ABS(y - sankarit(a%).y) THEN q% = ABS(x - sankarit(a%).x) ELSE q% = ABS(y - sankarit(a%).y)
    IF q% < r% THEN
      r% = q%
      w% = a%
    END IF
  NEXT a%
  closest.hero% = w%
END FUNCTION

'laskee vahingon tyylill xdy+c, x=1-9,y=1-9,c=1.... Ei vlej!
FUNCTION count.damage% (dam$)
  'damage:n max : 9d9 = 9...81
  dama% = 0
  times% = VAL(MID$(dam$, 1, 1)) 'montako kertaa heitetn
  cube% = VAL(MID$(dam$, 3, 1)) 'millaista noppaa
  bon% = VAL(MID$(dam$, 5, LEN(dam$) - 4))
  FOR a% = 1 TO times%
    dama% = dama% + INT(RND * cube%) + 1
  NEXT a%
  dama% = dama% + bon% 'bonus lopuksi
  count.damage% = dama%
END FUNCTION

SUB delay (aika AS INTEGER)
  FOR a% = 1 TO aika
    FOR B& = 1 TO delay.time
    NEXT
  NEXT
END SUB

'pttelee pelaajan [kuka] kuvan tmn taitojen perusteella
SUB determine.player.pic (kuka AS INTEGER)
  address% = 0: offset% = 0: nimi$ = ""
  SELECT CASE kuka
    CASE 1: address% = VARSEG(heropic1(1)): offset% = VARPTR(heropic1(1))
    CASE 2: address% = VARSEG(heropic2(1)): offset% = VARPTR(heropic2(1))
    CASE 3: address% = VARSEG(heropic3(1)): offset% = VARPTR(heropic3(1))
    CASE 4: address% = VARSEG(heropic4(1)): offset% = VARPTR(heropic4(1))
    CASE 5: address% = VARSEG(heropic5(1)): offset% = VARPTR(heropic5(1))
  END SELECT
  'ptelln kuva rodun, luokan ja varusteiden mukaan
  SELECT CASE sankarit(kuka).rotu
    CASE rotu.ihminen:
      SELECT CASE sankarit(kuka).luokka
        CASE luokka.maagi:
          IF suojaluokat(sankarit(kuka).armori).pisteet < 8 THEN
            nimi$ = "mage.pic"
          ELSEIF suojaluokat(sankarit(kuka).armori).pisteet < 16 THEN
            nimi$ = "magearm.pic"  'MAGI
          ELSE
            nimi$ = "magefarm.pic" 'MAGI Full ARMor
          END IF
        CASE luokka.barbaari:
          IF suojaluokat(sankarit(kuka).armori).pisteet < 8 THEN
            nimi$ = "barb.pic"
          ELSEIF suojaluokat(sankarit(kuka).armori).pisteet < 16 THEN
            nimi$ = "barbarm.pic"  'BARBarian ARMor
          ELSE
            nimi$ = "barbfarm.pic" 'BARBarian Full ARMor
          END IF
        CASE luokka.jousiampuja:
          IF suojaluokat(sankarit(kuka).armori).pisteet < 8 THEN
            nimi$ = "human.pic"
          ELSEIF suojaluokat(sankarit(kuka).armori).pisteet < 16 THEN
            nimi$ = "humarm.pic" 'ihminen armorissa
          ELSE
            nimi$ = "archfarm.pic"
          END IF

      END SELECT
  END SELECT
  loadpic nimi$, address%, offset%
END SUB

SUB draw.creature (x AS INTEGER, y AS INTEGER, mika AS INTEGER)
  IF mika < 0 THEN 'piirretn sankari
    SELECT CASE -mika
      CASE 1: PUT (x, y), heropic1, PSET
      CASE 2: PUT (x, y), heropic2, PSET
      CASE 3: PUT (x, y), heropic3, PSET
      CASE 4: PUT (x, y), heropic4, PSET
      CASE 5: PUT (x, y), heropic5, PSET
    END SELECT
  ELSE
    SELECT CASE hirviot(mika).tyyppi
      CASE 1: PUT (x, y), enemypic1, PSET
      CASE 2: PUT (x, y), enemypic2, PSET
      CASE 3: PUT (x, y), enemypic3, PSET
      CASE 4: PUT (x, y), enemypic4, PSET
      CASE 5: PUT (x, y), enemypic5, PSET
    END SELECT
  END IF
END SUB

SUB draw.map
  FOR y% = 1 TO 8
  FOR x% = 1 TO 16
    IF kartta(x% + mapx, y% + mapy).dat <> 0 THEN
      IF kartta(x% + mapx, y% + mapy).oliolink = 0 OR kartta(x% + mapx, y% + mapy).dat <> NAKYY THEN
        IF kartta(x% + mapx, y% + mapy).itemlink = 0 THEN
          SELECT CASE kartta(x% + mapx, y% + mapy).yleisobj
            CASE OBJ.MAA:
              SELECT CASE kartta(x% + mapx, y% + mapy).erikobj
                CASE OBJ.MAA.TUNNELI: PUT ((x% - 1) * 20, (y% - 1) * 20), groundpic, PSET
                CASE OBJ.MAA.LATTIA: PUT ((x% - 1) * 20, (y% - 1) * 20), roompic, PSET
              END SELECT
            CASE obj.este:
              SELECT CASE kartta(x% + mapx, y% + mapy).erikobj
                CASE OBJ.ESTE.MUURI: PUT ((x% - 1) * 20, (y% - 1) * 20), wallpic, PSET
                CASE OBJ.ESTE.VETTA: LINE ((x% - 1) * 20, (y% - 1) * 20)-((x% - 1) * 20 + 19, (y% - 1) * 20 + 19), 153 + INT(RND * 6), BF
                CASE obj.este.laava: LINE ((x% - 1) * 20, (y% - 1) * 20)-((x% - 1) * 20 + 19, (y% - 1) * 20 + 19), 72 + INT(RND * 6), BF
              END SELECT
            CASE OBJ.KASVI:
              PUT ((x% - 1) * 20, (y% - 1) * 20), plantpic, PSET
            CASE OBJ.OVI:
              IF kartta(x% + mapx, y% + mapy).erikobj <> OBJ.OVI.SALA THEN
                PUT ((x% - 1) * 20, (y% - 1) * 20), doorpic, PSET
              ELSE
                PUT ((x% - 1) * 20, (y% - 1) * 20), wallpic, PSET
              END IF
            CASE OBJ.PORTAAT:
              PUT ((x% - 1) * 20, (y% - 1) * 20), swaypic, PSET
          END SELECT
        ELSE
          IF esineet(kartta(x% + mapx, y% + mapy).itemlink).ketju = 0 THEN
            SELECT CASE esineet(kartta(x% + mapx, y% + mapy).itemlink).tyyppi
              CASE esine.ase: PUT ((x% - 1) * 20, (y% - 1) * 20), weaponpic, PSET
              CASE esine.kirja: PUT ((x% - 1) * 20, (y% - 1) * 20), bookpic, PSET
              CASE esine.juoma: PUT ((x% - 1) * 20, (y% - 1) * 20), bottlepic, PSET
              CASE esine.panssari, esine.kilpi, esine.kypara: PUT ((x% - 1) * 20, (y% - 1) * 20), armorpic, PSET
            END SELECT
          ELSE
            PUT ((x% - 1) * 20, (y% - 1) * 20), heappic, PSET
          END IF
        END IF
      ELSE
        CALL draw.creature((x% - 1) * 20, (y% - 1) * 20, kartta(x% + mapx, y% + mapy).oliolink)
      END IF
    ELSE
      LINE ((x% - 1) * 20, (y% - 1) * 20)-((x% - 1) * 20 + 19, (y% - 1) * 20 + 19), 0, BF
    END IF
  NEXT x%, y%
END SUB

'piirt komentopaneelin
SUB draw.panel
  CALL mousehide
  LINE (0, 160)-(319, 199), 20, B 'kaunis kehys
  FOR a% = 1 TO MAX.PLAYER
    IF a% <= pelaajia THEN
      CALL draw.creature((a% - 1) * 23 + 3, 163, -a%)
      IF a% = LEADER THEN
        LINE ((a% - 1) * 23 + 2, 162)-((a% - 1) * 23 + 23, 183), 12, B
      ELSE
        LINE ((a% - 1) * 23 + 2, 162)-((a% - 1) * 23 + 23, 183), 20, B
      END IF
    ELSE 'tm sangaritila ei kytss
      LINE ((a% - 1) * 23 + 3, 163)-((a% - 1) * 23 + 22, 182), 26
      LINE ((a% - 1) * 23 + 3, 182)-((a% - 1) * 23 + 22, 163), 26
    END IF
  NEXT
  LINE (301, 161)-(318, 178), 45, BF
  CALL upgr.panel
  'piirretn napit
  LINE (120, 171)-(201, 192), 20, B:
  PUT (121, 172), armorpic, PSET
  PUT (141, 172), bookpic, PSET
  PUT (161, 172), bottlepic, PSET
  PUT (181, 172), weaponpic, PSET
  CALL mouseshow
END SUB

'mista:0 = ylhlt, mista:1= alhaalta
SUB enter.dungeon (mista AS INTEGER)
  c% = 0
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF kartta(x%, y%).yleisobj = OBJ.PORTAAT THEN
      IF kartta(x%, y%).erikobj = OBJ.PORTAAT.ALAS AND mista = 1 THEN
        c% = 1: x1% = x%: y1% = y%: EXIT FOR
      ELSEIF kartta(x%, y%).erikobj = OBJ.PORTAAT.YLOS AND mista = 0 THEN
        c% = 2: x1% = x%: y1% = y%: EXIT FOR
      END IF
    END IF
  NEXT y%
    IF c% <> 0 THEN EXIT FOR
  NEXT x%
  'haetaan sangar(e)ille aloituspaikka
  CALL handle.map
  CALL see.area(x1%, y1%, 3)
  FOR kuka = 1 TO pelaajia
    x% = x1%: y% = y1%
    WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0 OR kartta(x%, y%).dat <> 1)
      x% = INT(RND * 5) - 2 + x1%: y% = INT(RND * 5) - 2 + y1%
    WEND
    kartta(x%, y%).oliolink = -kuka
    sankarit(kuka).x = x%: sankarit(kuka).y = y%
  NEXT
END SUB

'poistaa pelaajat luolasta
SUB exit.dungeon
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF kartta(x%, y%).oliolink < 0 THEN kartta(x%, y%).oliolink = 0
  NEXT y%, x%
END SUB

FUNCTION floor.round% (x AS SINGLE)
  'pyrist alaspin
  IF CINT(x) - x <= 0 THEN y% = CINT(x) ELSE y% = CINT(x) - 1
  floor.round% = y%
END FUNCTION

SUB getch
  Key$ = ""
  c% = 0
  WHILE Key$ = ""
    Key$ = INKEY$
    CALL mousestatus
    IF mouse.button <> 0 THEN c% = mouse.button
    IF mouse.button = 0 AND c% <> 0 THEN
      Key$ = "M" + STR$(c%)
    END IF
  WEND
END SUB

SUB h.inventory
  DIM kuka AS INTEGER
  kuka = LEADER
  sel% = 1 'valittu esine tavaraluettelosta
  selx% = 0: sely% = 0
  CALL mousehide
  LOCATE 12, 12: PRINT " Equip (RTN) "
  LOCATE 13, 12: PRINT " Use (SPC)   "
  LOCATE 14, 12: PRINT " (D)rop      "
  LOCATE 15, 12: PRINT " Exit (ESC)  "
  LINE (87, 87)-(191, 120), 12, B
  CALL mouseshow
  DO
    CALL mousehide
    LOCATE 9, 10
    IF inventory(kuka, sel%, itemtype) > 0 THEN
      SELECT CASE inventory(kuka, sel%, itemtype) - 1
        CASE esine.ase:
          PRINT aseluokat(inventory(kuka, sel%, itemlink)).nimi; " * Weapon *"
          LOCATE 10, 10: PRINT "Damage:"; aseluokat(inventory(kuka, sel%, itemlink)).damage; "ACP:"; aseluokat(inventory(kuka, sel%, itemlink)).pisteet; STRING$(5, " ")
        CASE esine.kirja:
          PRINT "Book of "; kirjaluokat(inventory(kuka, sel%, itemlink)).nimi
          LOCATE 10, 10: PRINT STRING$(31, " ")
        CASE esine.juoma:
          PRINT potions(inventory(kuka, sel%, itemlink)).nimi; " * Potion *"
          LOCATE 10, 10: PRINT STRING$(31, " ")
        CASE esine.kypara:
          PRINT kyparaluokat(inventory(kuka, sel%, itemlink)).nimi; " *Headgear*"
          LOCATE 10, 10: PRINT "Defense:"; kyparaluokat(inventory(kuka, sel%, itemlink)).pisteet; STRING$(18, " ")
        CASE esine.kilpi:
          PRINT kilpiluokat(inventory(kuka, sel%, itemlink)).nimi; " * Shield *"
          LOCATE 10, 10: PRINT "Defense:"; kilpiluokat(inventory(kuka, sel%, itemlink)).pisteet; STRING$(18, " ")
        CASE esine.panssari:
          PRINT suojaluokat(inventory(kuka, sel%, itemlink)).nimi; " * Armor  *"
          LOCATE 10, 10: PRINT "Defense:"; suojaluokat(inventory(kuka, sel%, itemlink)).pisteet; STRING$(18, " ")
      END SELECT
    ELSE
      PRINT STRING$(31, ".")
      LOCATE 10, 10: PRINT STRING$(31, ".")
    END IF
    LOCATE 1, 1
    PRINT SPACE$(10); sankarit(kuka).nimi
    PRINT "---------- PERSONAL EQUIPMENT ----------"
    PRINT "1) Weapon:"; aseluokat(sankarit(kuka).ase).nimi; aseluokat(sankarit(kuka).ase).damage; "*"; aseluokat(sankarit(kuka).ase).pisteet
    PRINT "2) Armor :"; suojaluokat(sankarit(kuka).armori).nimi; suojaluokat(sankarit(kuka).armori).pisteet
    PRINT "3) Shield:"; kilpiluokat(sankarit(kuka).kilpi).nimi; kilpiluokat(sankarit(kuka).kilpi).pisteet
    PRINT "4) Helm  :"; kyparaluokat(sankarit(kuka).kypara).nimi; kyparaluokat(sankarit(kuka).kypara).pisteet
    PRINT "----------     INVENTORY      ----------"
    x% = 0: y% = 0
    FOR a% = 1 TO max.item.carry
      IF inventory(kuka, a%, itemtype) > 0 THEN
      SELECT CASE inventory(kuka, a%, itemtype) - 1
        CASE esine.ase:
          PUT (10 + x% * 20, 60 + y% * 20), weaponpic, PSET
          'kyttkielto
          IF aseluokat(inventory(kuka, a%, itemlink)).pisteet > 1 AND (sankarit(kuka).luokka = luokka.maagi OR sankarit(kuka).rotu = rotu.haltia) THEN
            LINE (10 + x% * 20, 60 + y% * 20)-(29 + x% * 20, 79 + y% * 20), 14
            LINE (10 + x% * 20, 79 + y% * 20)-(29 + x% * 20, 60 + y% * 20), 14
          END IF
        CASE esine.kirja:
          PUT (10 + x% * 20, 60 + y% * 20), bookpic, PSET
        CASE esine.juoma:
          PUT (10 + x% * 20, 60 + y% * 20), bottlepic, PSET
        CASE esine.panssari, esine.kypara, esine.kilpi:
          PUT (10 + x% * 20, 60 + y% * 20), armorpic, PSET
      END SELECT
      ELSE
        PUT (10 + x% * 20, 60 + y% * 20), groundpic, PSET
      END IF
      IF a% = sel% THEN LINE (10 + x% * 20, 60 + y% * 20)-(29 + x% * 20, 79 + y% * 20), 14, B
      y% = y% + 1
      IF y% >= 4 THEN y% = 0: x% = x% + 1
    NEXT
    LINE (9, 59)-(70, 140), 14, B 'kehystetn esineet
    CALL draw.panel
    CALL mouseshow
    Key$ = "": c% = 0
    DO
      Key$ = INKEY$
      CALL mousestatus
      IF mouse.button THEN c% = mouse.button
      IF mouse.button = 0 AND c% <> 0 THEN EXIT DO 'hiiri vapautettu
      IF Key$ <> "" THEN EXIT DO
    LOOP
    IF c% <> 0 THEN
      IF mouse.x / 2 >= 10 AND mouse.x / 2 < 70 AND mouse.y >= 60 AND mouse.y < 140 THEN
        pre% = sel%
        selx% = INT(((mouse.x / 2) - 10) / 20): sely% = INT((mouse.y - 60) / 20)
        sel% = (selx% * 4 + sely%) + 1
        IF pre% = sel% THEN Key$ = CHR$(13)  'tuplaklik
        IF (c% AND 2) THEN Key$ = "d" 'drop
      ELSEIF mouse.x / 2 >= 87 AND mouse.x / 2 < 191 AND mouse.y >= 87 AND mouse.y < 120 THEN
        SELECT CASE INT((mouse.y - 87) / 8)
          CASE 0: Key$ = CHR$(13)  'equip
          CASE 1: Key$ = " "
          CASE 2: Key$ = "d"
          CASE 3: Key$ = CHR$(27)
        END SELECT
      ELSEIF mouse.y >= 16 AND mouse.y < 48 THEN
        Key$ = CHR$(ASC("1") + INT((mouse.y - 16) / 8))'1,2,3,4
      END IF
    END IF
    IF Key$ <> "" THEN
      IF Key$ = CHR$(27) THEN
        EXIT DO
      ELSEIF Key$ = CHR$(13) THEN 'puetaan
        IF inventory(kuka, sel%, itemtype) - 1 <> esine.juoma AND inventory(kuka, sel%, itemtype) - 1 <> esine.kirja AND inventory(kuka, sel%, itemtype) > 0 THEN
          SELECT CASE inventory(kuka, sel%, itemtype) - 1
            CASE esine.panssari:
              IF sankarit(kuka).armori <> 0 THEN
                SWAP inventory(kuka, sel%, itemlink), sankarit(kuka).armori
              ELSE
                sankarit(kuka).armori = inventory(kuka, sel%, itemlink)
                inventory(kuka, sel%, itemtype) = 0
              END IF
            CASE esine.kilpi:
              IF sankarit(kuka).kilpi <> 0 THEN
                SWAP inventory(kuka, sel%, itemlink), sankarit(kuka).kilpi
              ELSE
                sankarit(kuka).kilpi = inventory(kuka, sel%, itemlink)
                inventory(kuka, sel%, itemtype) = 0
              END IF
            CASE esine.kypara:
              IF sankarit(kuka).kypara <> 0 THEN
                SWAP inventory(kuka, sel%, itemlink), sankarit(kuka).kypara
              ELSE
                sankarit(kuka).kypara = inventory(kuka, sel%, itemlink)
                inventory(kuka, sel%, itemtype) = 0
              END IF
            CASE esine.ase
              IF aseluokat(inventory(kuka, sel%, itemlink)).pisteet > 1 AND (sankarit(kuka).luokka = luokka.maagi OR sankarit(kuka).rotu = rotu.haltia) THEN
                SOUND 100, .1
              ELSE
                IF sankarit(kuka).ase <> 0 THEN
                  SWAP inventory(kuka, sel%, itemlink), sankarit(kuka).ase
                ELSE
                  sankarit(kuka).ase = inventory(kuka, sel%, itemlink)
                  inventory(kuka, sel%, itemtype) = 0
                END IF
              END IF
          END SELECT
        END IF
        determine.player.pic kuka
      ELSEIF Key$ = "d" THEN
        IF inventory(kuka, sel%, itemtype) > 0 THEN
          FOR a% = 1 TO max.items
            IF esineet(a%).tyyppi = -1 THEN 'tm on pois plt
              esineet(a%).ketju = 0
              esineet(a%).tyyppi = inventory(kuka, sel%, itemtype) - 1
              esineet(a%).linkki = inventory(kuka, sel%, itemlink)
              CALL add.item.map(sankarit(kuka).x, sankarit(kuka).y, a%)
              inventory(kuka, sel%, itemtype) = 0
              EXIT FOR
            END IF
          NEXT a%
        END IF
      ELSEIF Key$ = " " THEN 'kytetn
        IF inventory(kuka, sel%, itemtype) - 1 = esine.kirja THEN
          'loitsu kohoaa levelin
          loitsut(kuka, inventory(kuka, sel%, itemlink)) = loitsut(kuka, inventory(kuka, sel%, itemlink)) + 1
          sankarit(kuka).loitsu = inventory(kuka, sel%, itemlink)
          inventory(kuka, sel%, itemtype) = 0
        END IF
      ELSEIF Key$ >= "1" AND Key$ <= "4" THEN
        FOR a% = 1 TO max.item.carry
          IF inventory(kuka, a%, itemtype) = 0 THEN
            'aktivoi, niin kursori hypp poistetun kohtaan
            'sel% = a%
            'selx% = INT(a% / 4)
            'sely% = sel% - selx% * 4 - 1
            SELECT CASE Key$
              CASE "1":
                IF sankarit(kuka).ase > 0 THEN
                  inventory(kuka, a%, itemtype) = esine.ase + 1
                  inventory(kuka, a%, itemlink) = sankarit(kuka).ase
                  sankarit(kuka).ase = 0
                END IF
              CASE "2":
                IF sankarit(kuka).armori > 0 THEN
                  inventory(kuka, a%, itemtype) = esine.panssari + 1
                  inventory(kuka, a%, itemlink) = sankarit(kuka).armori
                  sankarit(kuka).armori = 0
                END IF
              CASE "3":
                IF sankarit(kuka).kilpi > 0 THEN
                  inventory(kuka, a%, itemtype) = esine.kilpi + 1
                  inventory(kuka, a%, itemlink) = sankarit(kuka).kilpi
                  sankarit(kuka).kilpi = 0
                END IF
              CASE "4":
                IF sankarit(kuka).kypara > 0 THEN
                  inventory(kuka, a%, itemtype) = esine.kypara + 1
                  inventory(kuka, a%, itemlink) = sankarit(kuka).kypara
                  sankarit(kuka).kypara = 0
                END IF
            END SELECT
            EXIT FOR
          END IF
        NEXT
      determine.player.pic kuka
      ELSEIF Key$ = "n" THEN
        LEADER = LEADER + 1
        IF LEADER > pelaajia THEN LEADER = 1
        kuka = LEADER
      ELSEIF Key$ = oikea$ AND selx% < 2 THEN
        selx% = selx% + 1
      ELSEIF Key$ = vasen$ AND selx% > 0 THEN
        selx% = selx% - 1
      ELSEIF Key$ = alas$ AND sely% < 3 THEN
        sely% = sely% + 1
      ELSEIF Key$ = ylos$ AND sely% > 0 THEN
        sely% = sely% - 1
      END IF
      sel% = (selx% * 4 + sely%) + 1
    END IF
  LOOP
  Key$ = ""
END SUB

'piilottaa kartan - 2 jos paljastettu mutta ei nkkentss
SUB handle.map
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF kartta(x%, y%).dat <> 0 THEN kartta(x%, y%).dat = 2
  NEXT y%, x%
END SUB

SUB handle.map.area (x AS INTEGER, y AS INTEGER)
  kuka% = 0
  FOR x1% = x - 1 TO x + 1
  FOR y1% = y - 1 TO y + 1
    IF x1% > 0 AND y1% > 0 AND x1% <= max.x AND y1% <= max.y THEN
      IF kartta(x1%, y1%).oliolink < 0 THEN kuka% = kartta(x1%, y1%).oliolink: EXIT FOR
    END IF
  NEXT y1%, x1%
  IF kuka% <> 0 THEN
    SELECT CASE kartta(x, y).yleisobj
      CASE OBJ.OVI: 'ksitelln ovea
        SELECT CASE kartta(x, y).erikobj
          CASE OBJ.OVI.KIINNI:
            IF INT(RND * 2) = 0 THEN
              kartta(x, y).erikobj = obj.ovi.auki
              alarm "Gateway opened!"
            ELSE
              alarm "Gateway's stuck!"
            END IF
          CASE OBJ.OVI.LUKITTU:
            alarm "Gateway's locked! Need a key or kick!"
          CASE OBJ.OVI.SALA:
            IF INT(RND * 3) = 0 THEN
              alarm "Suddenly wall opens!"
              kartta(x, y).erikobj = obj.ovi.auki
            ELSE
              IF INT(RND * 4) = 0 THEN alarm "Strange pics on the wall..."
            END IF
        END SELECT
      CASE OBJ.KASVI
        IF kartta(x, y).erikobj = OBJ.KASVI.TUTKIMATON THEN
          a% = INT(RND * 20)
          IF a% = 0 THEN
            alarm "Charged Cappaces! Energy + 20%"
            sankarit(LEADER).mana = sankarit(LEADER).mana + INT(sankarit(LEADER).manax / 5)
            IF sankarit(LEADER).mana > sankarit(LEADER).manax THEN sankarit(LEADER).mana = sankarit(LEADER).manax
          ELSEIF a% = 5 THEN
            alarm "Apples of Anthem! Life + 20%"
            sankarit(LEADER).elo = sankarit(LEADER).elo + INT(sankarit(LEADER).elomax / 5)
            IF sankarit(LEADER).elo > sankarit(LEADER).elomax THEN sankarit(LEADER).elo = sankarit(LEADER).elomax
          ELSEIF a% = 10 THEN
            alarm "Sausages of Stupidity! Energy -20%"
            sankarit(LEADER).mana = sankarit(LEADER).mana - INT(sankarit(LEADER).manax / 5)
            IF sankarit(LEADER).mana < 0 THEN sankarit(LEADER).mana = 0
          ELSEIF a% = 15 THEN
            alarm "Poisoned Potatos! Life -20%"
            sankarit(LEADER).elo = sankarit(LEADER).elo - INT(sankarit(LEADER).elomax / 5)
            IF sankarit(LEADER).elo < 0 THEN sankarit(LEADER).elo = 0
          ELSE
            alarm "Neverending space of emptyness!"
          END IF
          kartta(x, y).erikobj = OBJ.KASVI.TUTKITTU
        END IF
      CASE OBJ.PORTAAT: 'portaita vain maanalaisissa paikoissa - voi palata - pit tallentaa
        CALL exit.dungeon 'poistetaan sankarit
        OPEN "map.dat" FOR OUTPUT AS #1
          PRINT #1, 0 'ei olla luomassa uutta vaan lataamassa
          PRINT #1, pelaajia
          PRINT #1, komennot
          PRINT #1, curr.file
          IF kartta(x, y).erikobj = OBJ.PORTAAT.ALAS THEN
            enter.dungeon 1 'porukka portaille ennen poistumista
            PRINT #1, alas.file
          ELSE
            'jos ylosana XXX, palataan maan pinnalle
            enter.dungeon 0 'porukka portaille ennen poistumista
            IF LEFT$(ylos.file, 4) = "XXXX" THEN
              CLOSE #1: save.map: RUN "main.bas"
            END IF
            PRINT #1, ylos.file
          END IF
        CLOSE #1
        CALL save.map
        RUN "crfield.bas" 'tehdn tai ladataan kentt
    END SELECT
  ELSE
    alarm "At least 1 hero nearby required."
  END IF
  IF kartta(x, y).itemlink <> 0 THEN
    IF kuka% = 0 THEN
      alarm "Hero must stand here to pick up."
    ELSE
      pick.up LEADER, x, y
    END IF
  END IF
  Key$ = ""
END SUB

SUB hero.graph

END SUB

'palauttaa etisyyden lhimpn sankariin x,y:st
FUNCTION hero.range% (x AS INTEGER, y AS INTEGER)
  r% = 100
  FOR a% = 1 TO pelaajia
    IF ABS(x - sankarit(a%).x) >= ABS(y - sankarit(a%).y) THEN q% = ABS(x - sankarit(a%).x) ELSE q% = ABS(y - sankarit(a%).y)
    IF q% < r% THEN r% = q%
  NEXT a%
  hero.range% = r%
END FUNCTION

SUB identify.block (pala AS MAP)
  nimi$ = "": onkoh = 0: hcol% = 0
  itemi$ = "": onkoi = 0: icol% = 0
  maap$ = "": elo% = 0
  IF pala.dat = 0 THEN
    maap$ = "Unseen area"
  ELSE
    SELECT CASE pala.yleisobj
    CASE OBJ.MAA
      SELECT CASE pala.erikobj
        CASE OBJ.MAA.TUNNELI: maap$ = "Ground section"
        CASE OBJ.MAA.LATTIA: maap$ = "Floor section"
      END SELECT
    CASE obj.este
      SELECT CASE pala.erikobj
        CASE OBJ.ESTE.MUURI: maap$ = "Wall"
        CASE OBJ.ESTE.VETTA: maap$ = "Water"
      END SELECT
    CASE OBJ.KASVI
      maap$ = "Plant"
    CASE OBJ.OVI
      SELECT CASE pala.erikobj
        CASE obj.ovi.auki: maap$ = "Open gateway"
        CASE OBJ.OVI.KIINNI: maap$ = "Closed gateway"
        CASE OBJ.OVI.LUKITTU: maap$ = "Locked gateway"
        CASE OBJ.OVI.SALA: maap$ = "Wall"
      END SELECT
    CASE OBJ.PORTAAT:
      SELECT CASE pala.erikobj
        CASE OBJ.PORTAAT.YLOS: maap$ = "Stairway up"
        CASE OBJ.PORTAAT.ALAS: maap$ = "Stairway down"
      END SELECT

    END SELECT
    IF pala.oliolink <> 0 THEN
      IF pala.oliolink < 0 THEN
        nimi$ = sankarit(ABS(pala.oliolink)).nimi$
        hcol% = 13
        elo% = (198 / sankarit(ABS(pala.oliolink)).elomax) * sankarit(ABS(pala.oliolink)).elo
      ELSE
        nimi$ = hirvioluokka(hirviot(pala.oliolink).tyyppi).nimi
        elo% = (198 / hirvioluokka(hirviot(pala.oliolink).tyyppi).elomax) * hirviot(pala.oliolink).elo
        hcol% = 14
      END IF
      onkoh = -1
    END IF
    IF pala.itemlink <> 0 THEN
      IF esineet(pala.itemlink).ketju = 0 THEN
        SELECT CASE esineet(pala.itemlink).tyyppi
          CASE esine.ase: itemi$ = aseluokat(esineet(pala.itemlink).linkki).nimi: icol% = 12
          CASE esine.kirja: itemi$ = kirjaluokat(esineet(pala.itemlink).linkki).nimi: icol% = 40
          CASE esine.juoma: itemi$ = potions(esineet(pala.itemlink).linkki).nimi: icol% = 40
          CASE esine.panssari: itemi$ = suojaluokat(esineet(pala.itemlink).linkki).nimi: icol% = 27
          CASE esine.kilpi: itemi$ = kilpiluokat(esineet(pala.itemlink).linkki).nimi: icol% = 27
          CASE esine.kypara: itemi$ = kyparaluokat(esineet(pala.itemlink).linkki).nimi: icol% = 27
        END SELECT
      ELSE
        maara% = 0: a% = pala.itemlink
        DO
          IF a% = 0 THEN EXIT DO'=0 jo ketjun viimeinen, -1 jos palassa ei lainkaan esinett
          maara% = maara% + 1
          a% = esineet(a%).ketju
        LOOP
        itemi$ = "Heap of" + STR$(maara%) + " items"
        icol% = 1
      END IF
      onkoi = -1
    END IF
  END IF
 
  CALL round(63, 55, 200, 9)
  LINE (64, 56)-(262, 63), 0, BF
  LOCATE 8, 9: COLOR 15: PRINT maap$
  IF onkoh THEN
    CALL round(63, 79, 200, 10)
    LINE (64, 80)-(262, 88), 0, BF
    LINE (64, 88)-(64 + elo%, 88), 12, BF
    LOCATE 11, 9: COLOR hcol%: PRINT nimi$
  END IF
  IF onkoi THEN
    CALL round(63, 103, 200, 9)
    LINE (64, 104)-(262, 112), 0, BF
    LOCATE 14, 9: COLOR icol%: PRINT itemi$
  END IF
 
  DO
    CALL mousestatus
    IF mouse.button = 0 THEN EXIT DO
  LOOP
  COLOR 15
END SUB

SUB initgraph
  'otetaan paletti maailman mukaan
  SELECT CASE worldstyle
    CASE world.style.dungeon: CALL load.bmp("dungeon.bmp", 0)
    CASE world.style.village: CALL load.bmp("village.bmp", 0)
    CASE world.style.forest, world.style.grassland:  CALL load.bmp("forest.bmp", 0)
    CASE world.style.hell:  CALL load.bmp("hellpal.bmp", 0)
  END SELECT

  FOR a% = 1 TO pelaajia
    determine.player.pic a%
    'Vapauta, ja sankarit ovat healautuneet pelin alussa :)
'    sankarit(a%).elo = sankarit(a%).elomax
'    sankarit(a%).mana = sankarit(a%).manax
  NEXT

  CALL loadpic("weapon.pic", VARSEG(weaponpic(1)), VARPTR(weaponpic(1)))
  CALL loadpic("itemheap.pic", VARSEG(heappic(1)), VARPTR(heappic(1)))
  CALL loadpic("book.pic", VARSEG(bookpic(1)), VARPTR(bookpic(1)))
  CALL loadpic("bottle.pic", VARSEG(bottlepic(1)), VARPTR(bottlepic(1)))
  CALL loadpic("armor.pic", VARSEG(armorpic(1)), VARPTR(armorpic(1)))
  CALL loadpic("door.pic", VARSEG(doorpic(1)), VARPTR(doorpic(1)))
  CALL loadpic("stairway.pic", VARSEG(swaypic(1)), VARPTR(swaypic(1)))

  SELECT CASE worldstyle
    CASE world.style.dungeon:
      CALL loadpic("grass.pic", VARSEG(groundpic(1)), VARPTR(groundpic(1)))
      CALL loadpic("dungwall.pic", VARSEG(wallpic(1)), VARPTR(wallpic(1)))
      CALL loadpic("stony.pic", VARSEG(roompic(1)), VARPTR(roompic(1)))
      CALL loadpic("entangle.pic", VARSEG(plantpic(1)), VARPTR(plantpic(1)))
    CASE world.style.forest, world.style.grassland:
      CALL loadpic("grass.pic", VARSEG(groundpic(1)), VARPTR(groundpic(1)))
      CALL loadpic("rockflr.pic", VARSEG(wallpic(1)), VARPTR(wallpic(1)))
      CALL loadpic("stony.pic", VARSEG(roompic(1)), VARPTR(roompic(1)))
      CALL loadpic("tree.pic", VARSEG(plantpic(1)), VARPTR(plantpic(1)))
    CASE world.style.hell:
      CALL loadpic("boneland.pic", VARSEG(groundpic(1)), VARPTR(groundpic(1)))
      CALL loadpic("bonewall.pic", VARSEG(wallpic(1)), VARPTR(wallpic(1)))
      CALL loadpic("muddy.pic", VARSEG(roompic(1)), VARPTR(roompic(1)))
      CALL loadpic("entangle.pic", VARSEG(plantpic(1)), VARPTR(plantpic(1)))
    CASE world.style.village:
  END SELECT
END SUB

SUB items
'ladataan esineet
  OPEN "items.dat" FOR BINARY AS #1
 
  FOR a% = 1 TO MAX.WEAPONS
    GET #1, , aseluokat(a%).nimi
    GET #1, , aseluokat(a%).pisteet
    GET #1, , aseluokat(a%).hrange
    GET #1, , aseluokat(a%).damage
  NEXT a%
 
  FOR a% = 1 TO MAX.BOOK
    GET #1, , kirjaluokat(a%).nimi
    GET #1, , q%
    GET #1, , kirjaluokat(a%).dam
  NEXT a%
 
  DIM d AS STRING * 6 'tll otetaan turha string vlist pois
 
  FOR a% = 1 TO MAX.BOTTLES
    GET #1, , potions(a%).nimi
    GET #1, , potions(a%).mita
    GET #1, , d
  NEXT a%
 
  FOR a% = 1 TO MAX.ARMOR
    GET #1, , suojaluokat(a%).nimi
    GET #1, , suojaluokat(a%).pisteet
    GET #1, , d
  NEXT a%
  FOR a% = 1 TO MAX.SHIELD
    GET #1, , kilpiluokat(a%).nimi
    GET #1, , kilpiluokat(a%).pisteet
    GET #1, , d
  NEXT a%
  FOR a% = 1 TO MAX.HELMET
    GET #1, , kyparaluokat(a%).nimi
    GET #1, , kyparaluokat(a%).pisteet
    GET #1, , d
  NEXT a%
 
  aseluokat(0).nimi = "Fist"
  aseluokat(0).pisteet = 1
  aseluokat(0).hrange = 1
  aseluokat(0).damage = "1d2"

  suojaluokat(0).nimi = "--------NONE--------"
  suojaluokat(0).pisteet = 0
 
  kyparaluokat(0).nimi = "--------NONE--------"
  kyparaluokat(0).pisteet = 0
 
  kilpiluokat(0).nimi = "--------NONE--------"
  kilpiluokat(0).pisteet = 0

  CLOSE #1
END SUB

FUNCTION last.item% (pala AS MAP)
  a% = pala.itemlink: B% = 0
  maara% = 0
  IF a% = 0 THEN B% = -1 ELSE B% = 1
  DO
    IF a% = 0 OR B% < 1 THEN EXIT DO'=0 jo ketjun viimeinen, -1 jos palassa ei lainkaan esinett
    maara% = maara% + 1
    B% = a% 'esineen numero
    a% = esineet(a%).ketju
  LOOP
  last.item% = B%
END FUNCTION

SUB load.bmp (filename$, drawit AS INTEGER)

'bittikartan lataaja - piirt mokoman - (c) Tarmo Korpela

OPEN filename$ FOR BINARY AS #1

header$ = SPACE$(14)
sizing$ = SPACE$(4)
GET #1, 1, header$ 'headeri
GET #1, 15, sizing$ 'kokoluokittelu
bmpinfosize = CVI(sizing$) 'paljonko infoa
IF bmpinfosize = 12 THEN '12 tavua
   infoheader$ = SPACE$(12)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))

   IF nbits = 1 THEN       '1-vrinen
      palet$ = SPACE$(6)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN   '16 vri
      palet$ = SPACE$(48)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN   '256
      palet$ = SPACE$(768)
      GET #1, bmpinfosize + 15, palet$
   END IF
ELSEIF bmpinfosize = 40 THEN '40 tavua
   infoheader$ = SPACE$(40)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))
   IF nbits = 1 THEN   '1-vrinen
      palet$ = SPACE$(8)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN  '16
      palet$ = SPACE$(64)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN  '256
      palet$ = SPACE$(1024)
      GET #1, bmpinfosize + 15, palet$
   END IF
END IF
 

ft$ = MID$(header$, 1, 2)

filesize = CVL(MID$(header$, 3, 4)) 'tiedoston koko

r1 = CVI(MID$(header$, 7, 2))

r2 = CVI(MID$(header$, 9, 2))

offset = CVL(MID$(header$, 11, 4))


headersize = CVL(MID$(infoheader$, 1, 4))

picwidth = CVL(MID$(infoheader$, 5, 4))

picheight = CVL(MID$(infoheader$, 9, 4))

nplanes = CVI(MID$(infoheader$, 13, 4))


IF headersize = 40 THEN
   comptype = CVL(MID$(infoheader$, 17, 4))

   imagesize = CVL(MID$(infoheader$, 21, 4))

   xsize = CVL(MID$(infoheader$, 25, 4))

   ysize = CVL(MID$(infoheader$, 29, 4))

   colorsused = CVL(MID$(infoheader$, 33, 4))

   neededcolours = CVL(MID$(infoheader$, 37, 4))
END IF

IF nbits = 1 THEN
   SCREEN 11
ELSEIF nbits = 4 THEN
   SCREEN 12
ELSEIF nbits = 8 OR nbits = 24 THEN
   SCREEN 13
END IF

IF bmpinfosize = 40 THEN ngroups = 4
IF bmpinfosize = 12 THEN ngroups = 3

IF nbits = 24 THEN
   IF ngroups = 3 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d)
      NEXT c
   ELSEIF ngroups = 4 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d) + CHR$(0)
      NEXT c
   END IF
END IF

FOR x = 1 TO LEN(palet$) STEP ngroups
   zb# = INT((ASC(MID$(palet$, x, 1))) / 4)
   zg# = INT((ASC(MID$(palet$, x + 1, 1))) / 4)
   zr# = INT((ASC(MID$(palet$, x + 2, 1))) / 4)
   zc# = zb# * 65536# + zg# * 256# + zr#
   cres = ASC(MID$(palet$, x + 3, 1))
   PALETTE ((x - 1) / ngroups), zc#
NEXT x

'piirretn kuva

IF drawit = 1 THEN
  IF nbits = 24 THEN
    y = picheight - 1
    x = 0
    dat$ = "   "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        p1 = INT((ASC(MID$(dat$, 1, 1)) + ASC(MID$(dat$, 1, 1)) + ASC(MID$(dat$, 1, 1))) / 3)
        PUT x, y, p1
        x = x + 1
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 8 THEN
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        p1 = ASC(dat$)
        PUT x, y, p1
        x = x + 1
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 4 THEN '16 vri
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        LOCATE 1, 1
        p1 = ASC(dat$) AND 15
        p2 = ASC(dat$) AND 240 / 16
        PUT x, y, p1: PUT x + 1, y, p2
        x = x + 2
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 1 THEN
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        p1 = ASC(dat$)
        p3 = 1
        FOR p = 0 TO 7
          p2 = ABS((p1 AND p3) <> 0) '1 jos tosi, 0 jos ei
          PUT x, y, p2
          p3 = p3 * 2 'muutetaan
          x = x + 1
        NEXT p
      WEND
      y = y - 1
      x = 0
    WEND
  END IF
END IF

CLOSE #1

END SUB

SUB load.values
  OPEN "heroes.dat" FOR BINARY AS #1
  FOR a% = 1 TO MAX.PLAYER
    GET #1, , sankarit(a%).rotu
    GET #1, , sankarit(a%).luokka
    GET #1, , sankarit(a%).acpmax
    GET #1, , sankarit(a%).nimi
    GET #1, , sankarit(a%).elo
    GET #1, , sankarit(a%).elomax
    GET #1, , sankarit(a%).mana
    GET #1, , sankarit(a%).manax
   
    GET #1, , sankarit(a%).ase
    GET #1, , sankarit(a%).kypara
    GET #1, , sankarit(a%).kilpi
    GET #1, , sankarit(a%).armori
    GET #1, , sankarit(a%).loitsu
    'inventory
    FOR B% = 1 TO max.item.carry
      GET #1, , inventory(a%, B%, itemtype)
      GET #1, , inventory(a%, B%, itemlink)
    NEXT B%
    FOR B% = 1 TO MAX.BOOK
      GET #1, , loitsut(a%, B%)
    NEXT B%
    sankarit(a%).acpoints = sankarit(a%).acpmax
  NEXT
  CLOSE #1

END SUB

' ladataan kartta
SUB loadmap
  PRINT "Loading map... please wait"
  OPEN "map.dat" FOR INPUT AS #2
    INPUT #2, a%, pelaajia
    INPUT #2, komennot  'komentoluku
    INPUT #2, kutsuja$ 'kutsuja
    INPUT #2, file$
  CLOSE #2
  'otetaan kerros
  IF LEFT$(file$, 1) = "D" THEN
    kkerros = VAL(MID$(file$, 6, 2))
  ELSE
    kkerros = 0
  END IF
  curr.file = file$
  OPEN file$ FOR BINARY AS #1
  GET #1, 1, worldstyle
  FOR x% = 1 TO max.x
    FOR y% = 1 TO max.y
      GET #1, , kartta(x%, y%).dat
      GET #1, , kartta(x%, y%).yleisobj
      GET #1, , kartta(x%, y%).erikobj
      GET #1, , kartta(x%, y%).oliolink
      GET #1, , kartta(x%, y%).itemlink
  NEXT y%, x%
  FOR x% = 1 TO max.items
    GET #1, , esineet(x%).linkki
    GET #1, , esineet(x%).tyyppi
    GET #1, , esineet(x%).ketju
  NEXT x%
  FOR a% = 1 TO MAX.H.TYPE
    GET #1, , hirvioluokka(a%).nimi
    GET #1, , hirvioluokka(a%).file
    GET #1, , hirvioluokka(a%).elomax
    GET #1, , hirvioluokka(a%).range
    GET #1, , hirvioluokka(a%).steps
    GET #1, , hirvioluokka(a%).pase
    GET #1, , hirvioluokka(a%).spec
    SELECT CASE a%
      CASE 1: loadpic hirvioluokka(a%).file, VARSEG(enemypic1(1)), VARPTR(enemypic1(1))
      CASE 2: loadpic hirvioluokka(a%).file, VARSEG(enemypic2(1)), VARPTR(enemypic2(1))
      CASE 3: loadpic hirvioluokka(a%).file, VARSEG(enemypic3(1)), VARPTR(enemypic3(1))
      CASE 4: loadpic hirvioluokka(a%).file, VARSEG(enemypic4(1)), VARPTR(enemypic4(1))
      CASE 5: loadpic hirvioluokka(a%).file, VARSEG(enemypic5(1)), VARPTR(enemypic5(1))
    END SELECT
  NEXT a%
  GET #1, , ylos.file
  GET #1, , alas.file
  'hirvipuskuri
  FOR a% = 1 TO max.monsters
    GET #1, , hirviot(a%).tyyppi
    GET #1, , hirviot(a%).x
    GET #1, , hirviot(a%).y
    GET #1, , hirviot(a%).elo
    GET #1, , hirviot(a%).onoff
    GET #1, , hirviot(a%).ase
    'PRINT hirviot(a%).tyyppi; hirviot(a%).x; hirviot(a%).y; hirviot(a%).elo; hirviot(a%).onoff; hirviot(a%).ase: getch
    hirviot(a%).ls = -1
  NEXT a%
  CLOSE #1
  'asetetaan sankarit

  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF kartta(x%, y%).oliolink < 0 THEN
      sankarit(ABS(kartta(x%, y%).oliolink)).x = x%
      sankarit(ABS(kartta(x%, y%).oliolink)).y = y%
      sankarit(ABS(kartta(x%, y%).oliolink)).kx = x%
      sankarit(ABS(kartta(x%, y%).oliolink)).ky = y%
    END IF
  NEXT y%, x%
  CALL load.values 'ladataan sankarit
  CALL initgraph 'ladataan grafiikka
END SUB

SUB loadpic (nimi$, address%, offset%)
  DEF SEG = address%
  BLOAD nimi$, offset%
END SUB

SUB minimap
  CALL mousehide
  LOCATE 8, 17: COLOR 13: PRINT "Mini Map": COLOR 15
  CALL round(127, 55, 65, 9)
  CALL round(120, 80, max.x, max.y)
  locx% = 120: locy% = 80
  FOR y% = 1 TO max.y
  FOR x% = 1 TO max.x
    IF kartta(x%, y%).dat <> 0 THEN
      IF kartta(x%, y%).oliolink = 0 OR kartta(x%, y%).dat <> NAKYY THEN
        SELECT CASE kartta(x%, y%).yleisobj
          CASE OBJ.MAA: PSET (locx% + x%, locy% + y%), 244
          CASE obj.este:
            SELECT CASE kartta(x%, y%).erikobj
              CASE OBJ.ESTE.MUURI: PSET (locx% + x%, locy% + y%), 84
              CASE OBJ.ESTE.VETTA: PSET (locx% + x%, locy% + y%), 153 + INT(RND * 6)
              CASE obj.este.laava: PSET (locx% + x%, locy% + y%), 73 + INT(RND * 6)
            END SELECT
          CASE OBJ.OVI:
            IF kartta(x%, y%).erikobj <> OBJ.OVI.SALA THEN PSET (locx% + x%, locy% + y%), 26 ELSE PSET (locx% + x%, locy% + y%), 84
          CASE OBJ.PORTAAT: PSET (locx% + x%, locy% + y%), 126
          CASE OBJ.KASVI: PSET (locx% + x%, locy% + y%), 55
        END SELECT
      ELSE
          IF kartta(x%, y%).oliolink > 0 THEN
            PSET (x% + locx%, y% + locy%), 4
          ELSE
            PSET (x% + locx%, y% + locy%), 12
          END IF
      END IF
    ELSE
      PSET (x% + locx%, y% + locy%), 0
    END IF
  NEXT x%, y%
  CALL mouseshow
  x% = 64: y% = 1: pyyhi.nappain
  WHILE Key$ = ""
    Key$ = INKEY$
    x% = x% + y%
    IF x% > 78 THEN y% = -1
    IF x% < 66 THEN y% = 1
    CALL delay(50)
    LINE (mapx + locx%, mapy + locy%)-(mapx + 16 + locx%, mapy + locy% + 10), x% - 16, B
    FOR kuka = 1 TO pelaajia
      PSET (sankarit(kuka).x + locx%, sankarit(kuka).y + locy%), x%
      'LINE (sankarit(kuka).x + locx% - 1, sankarit(kuka).y + locy% - 1)-(sankarit(kuka).x + locx% + 1, sankarit(kuka).y + locy% + 1), x%, B
    NEXT
  WEND
  
END SUB

'liikuttaa vihollisia
SUB monster.move
  xm% = 0: ym% = 0'mihin liikutaan
  FOR a% = 1 TO max.monsters
    c% = 0
    IF hirviot(a%).onoff THEN
      FOR e% = 1 TO hirvioluokka(hirviot(a%).tyyppi).steps
        IF hero.range(hirviot(a%).x, hirviot(a%).y) <= hirvioluokka(hirviot(a%).tyyppi).range THEN
          q% = closest.hero(hirviot(a%).x, hirviot(a%).y)
          IF aseluokat(hirviot(a%).ase).hrange > 1 AND aseluokat(hirviot(a%).ase).hrange >= hero.range(hirviot(a%).x, hirviot(a%).y) AND c% = 0 THEN
            xm% = hirviot(a%).x: ym% = hirviot(a%).y
            FOR w% = 1 TO aseluokat(hirviot(a%).ase).hrange
              IF hirviot(a%).x < sankarit(q%).x THEN
                xm% = xm% + 1
              ELSEIF hirviot(a%).x > sankarit(q%).x THEN
                xm% = xm% - 1
              END IF
              IF hirviot(a%).y < sankarit(q%).y THEN
                ym% = ym% + 1
              ELSEIF hirviot(a%).y > sankarit(q%).y THEN
                ym% = ym% - 1
              END IF
              IF onkoeste(xm%, ym%, 0) THEN
                c% = 0: EXIT FOR 'tuli este
              ELSEIF kartta(xm%, ym%).oliolink < 0 THEN
                c% = 1: EXIT FOR
              END IF
            NEXT w%
            IF c% = 1 THEN 'ammutaan
              attack.to a%, kartta(xm%, ym%).oliolink
              IF aseluokat(sankarit(ABS(kartta(xm%, ym%).oliolink)).ase).hrange >= aseluokat(hirviot(a%).ase).hrange THEN attack.to kartta(xm%, ym%).oliolink, a%
            END IF
          END IF
          xm% = 0: ym% = 0
          IF hirviot(a%).x < sankarit(q%).x THEN
            xm% = 1
          ELSEIF hirviot(a%).x > sankarit(q%).x THEN
            xm% = -1
          END IF
          IF hirviot(a%).y < sankarit(q%).y THEN
            ym% = 1
          ELSEIF hirviot(a%).y > sankarit(q%).y THEN
            ym% = -1
          END IF
        ELSE 'sattumanvarainen liikkuminen
          xm% = INT(RND * 3) - 1: ym% = INT(RND * 3) - 1
        END IF
       
        IF c% = 1 THEN xm% = 0: ym% = 0'jos ampui

         
          'vistliike esteit varten
          IF onkoeste(hirviot(a%).x + xm%, hirviot(a%).y + ym%, 0) THEN
            IF xm% <> 0 AND ym% <> 0 THEN
              IF NOT onkoeste(hirviot(a%).x + xm%, hirviot(a%).y, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(xm%, 0) THEN
                ym% = 0
              ELSEIF NOT onkoeste(hirviot(a%).x - xm%, hirviot(a%).y, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-xm%, 0) THEN
                xm% = 0 - xm%: ym% = 0
              ELSEIF NOT onkoeste(hirviot(a%).x, hirviot(a%).y - ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(0, -ym%) THEN
                xm% = 0: ym% = 0 - ym%
              ELSEIF NOT onkoeste(hirviot(a%).x, hirviot(a%).y + ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(0, ym%) THEN
                xm% = 0
              ELSEIF NOT onkoeste(hirviot(a%).x - xm%, hirviot(a%).y + ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-xm%, ym%) THEN
                xm% = 0 - xm%
              ELSEIF NOT onkoeste(hirviot(a%).x + xm%, hirviot(a%).y - ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(xm%, -ym%) THEN
                ym% = 0 - ym%
              ELSE 'peruutetaan
                xm% = 0 - xm%: ym% = 0 - ym%
              END IF
            ELSE
              IF xm% <> 0 THEN
                IF NOT onkoeste(hirviot(a%).x + xm%, hirviot(a%).y - 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(xm%, -1) THEN
                  ym% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x + xm%, hirviot(a%).y + 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(xm%, 1) THEN
                  ym% = 1
                ELSEIF NOT onkoeste(hirviot(a%).x, hirviot(a%).y - 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(0, -1) THEN
                  xm% = 0: ym% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x, hirviot(a%).y + 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(0, 1) THEN
                  xm% = 0: ym% = 1
                ELSEIF NOT onkoeste(hirviot(a%).x - xm%, hirviot(a%).y - 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-xm%, -1) THEN
                  xm% = 0 - xm%: ym% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x - xm%, hirviot(a%).y + 1, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-xm%, 1) THEN
                  xm% = 0 - xm%: ym% = 1
                ELSE
                  xm% = 0 - xm%
                END IF
              ELSE
                IF NOT onkoeste(hirviot(a%).x - 1, hirviot(a%).y + ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-1, ym%) THEN
                  xm% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x + 1, hirviot(a%).y + ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(1, ym%) THEN
                  xm% = 1
                ELSEIF NOT onkoeste(hirviot(a%).x - 1, hirviot(a%).y, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-1, 0) THEN
                  ym% = 0: xm% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x + 1, hirviot(a%).y, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(1, 0) THEN
                  ym% = 0: xm% = 1
                ELSEIF NOT onkoeste(hirviot(a%).x - 1, hirviot(a%).y - ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(-1, -ym%) THEN
                  ym% = 0 - ym%: xm% = -1
                ELSEIF NOT onkoeste(hirviot(a%).x + 1, hirviot(a%).y - ym%, 0) AND vastasuunta(hirviot(a%).ls) <> suuntabyxm(1, -ym%) THEN
                  ym% = 0 - ym%: xm% = 1
                ELSE
                  ym% = 0 - ym%
                END IF
              END IF
            END IF
          END IF
        IF onkoeste(hirviot(a%).x + xm%, hirviot(a%).y + ym%, 0) THEN
          xm% = 0: ym% = 0
        END IF
        IF xm% <> 0 OR ym% <> 0 THEN 'liikutaan
          IF kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink <> 0 THEN
            IF kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink < 0 THEN
              CALL attack.to(a%, kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink)
              CALL attack.to(kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink, a%)
              EXIT FOR
            ELSE
              kartta(hirviot(a%).x, hirviot(a%).y).oliolink = kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink
              hirviot(kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink).x = hirviot(a%).x
              hirviot(kartta(hirviot(a%).x + xm%, hirviot(a%).y + ym%).oliolink).y = hirviot(a%).y
            END IF
          END IF
          IF kartta(hirviot(a%).x, hirviot(a%).y).oliolink = a% THEN kartta(hirviot(a%).x, hirviot(a%).y).oliolink = 0
          hirviot(a%).ls = suuntabyxm(xm%, ym%)
          hirviot(a%).x = hirviot(a%).x + xm%
          hirviot(a%).y = hirviot(a%).y + ym%
          kartta(hirviot(a%).x, hirviot(a%).y).oliolink = a%
          IF kartta(hirviot(a%).x, hirviot(a%).y).dat = 1 THEN
            SOUND 200, .1: CALL delay(50) 'askelten net
            CALL draw.map
          END IF
        END IF
      NEXT e%
    ELSE 'tm hirvi ei hengiss - regenerate!
      IF (komennot AND 1) THEN
        hirviot(a%).x = INT(RND * max.x) + 1
        hirviot(a%).y = INT(RND * max.y) + 1
        'hirvi ilmaantuu ties mist kartalle (nkemttmlle alueelle)
        IF INT(RND * 40) = 0 AND NOT onkoeste(hirviot(a%).x, hirviot(a%).y, 0) AND kartta(hirviot(a%).x, hirviot(a%).y).dat <> 1 THEN
          hirviot(a%).onoff = (1 = 1)
          hirviot(a%).ls = -1
          hirviot(a%).tyyppi = INT(RND * 5) + 1
          hirviot(a%).elo = hirvioluokka(hirviot(a%).tyyppi).elomax
          hirviot(a%).ase = hirvioluokka(hirviot(a%).tyyppi).pase
        END IF
      END IF
    END IF
  NEXT a%
END SUB

SUB MouseDriver (AX%, BX%, CX%, DX%)
  DEF SEG = VARSEG(mouse$)
  mouse% = SADD(mouse$)
  CALL Absolute(AX%, BX%, CX%, DX%, mouse%)
END SUB

SUB mousehide
 AX% = 2
 MouseDriver AX%, 0, 0, 0
END SUB

FUNCTION MouseInit%
  AX% = 0
  MouseDriver AX%, 0, 0, 0
  MouseInit% = AX%
END FUNCTION

SUB MousePut (x%, y%)
  AX% = 4
  CX% = x%
  DX% = y%
  MouseDriver AX%, 0, CX%, DX%
END SUB

SUB mouseshow
  AX% = 1
  MouseDriver AX%, 0, 0, 0
END SUB

SUB mousestatus
  AX% = 3
  MouseDriver AX%, BX%, CX%, DX%
  mouse.button = BX%
  mouse.x = CX%
  mouse.y = DX%
END SUB

'
' liikuttaa palaajaa kuka xm(-1,0,1) ja ym(-1,0,1) suuntiin.
'
SUB move.hero (kuka AS INTEGER, xm%, ym%)
IF sankarit(kuka).acpoints > 0 THEN
  IF kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).yleisobj = obj.este THEN
    pass% = 0
    IF kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).erikobj = OBJ.ESTE.MUURI THEN
      pass% = 0
    END IF
  ELSE
    IF kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink <> 0 THEN
      pass% = 2 'olion kohtaaminen
    ELSE
      pass% = 1
    END IF
  END IF
  IF pass% = 2 THEN 'kohtasi olennon
    IF kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink > 0 THEN
      IF sankarit(kuka).acpoints >= aseluokat(sankarit(kuka).ase).pisteet THEN
        CALL attack.to(-kuka, kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink)
        'jos ji henkiin, ly takaisin!
        IF kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink <> 0 THEN CALL attack.to(kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink, -kuka)
        sankarit(kuka).acpoints = sankarit(kuka).acpoints - aseluokat(sankarit(kuka).ase).pisteet
      ELSE   'ei riit varat lyntiin; pyshdytn
        sankarit(kuka).kx = sankarit(kuka).x: sankarit(kuka).ky = sankarit(kuka).y
      END IF
    ELSE 'sangari
      sankarit(ABS(kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink)).x = sankarit(kuka).x
      sankarit(ABS(kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink)).y = sankarit(kuka).y
      sankarit(ABS(kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink)).kx = sankarit(kuka).x
      sankarit(ABS(kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink)).ky = sankarit(kuka).y
      kartta(sankarit(kuka).x, sankarit(kuka).y).oliolink = kartta(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%).oliolink
      pass% = 1
    END IF
  END IF
  IF pass% = 1 THEN 'etenee ilman esteit
    IF kartta(sankarit(kuka).x, sankarit(kuka).y).oliolink = -kuka THEN kartta(sankarit(kuka).x, sankarit(kuka).y).oliolink = 0
    sankarit(kuka).x = sankarit(kuka).x + xm%: sankarit(kuka).y = sankarit(kuka).y + ym%
    kartta(sankarit(kuka).x, sankarit(kuka).y).oliolink = -kuka
    sankarit(kuka).acpoints = sankarit(kuka).acpoints - 1
  END IF
END IF
END SUB

'liikuttaa sankaria kohteeseen (kvelymoodi)
SUB movehero (kuka AS INTEGER)
  IF sankarit(kuka).kx < 1 OR sankarit(kuka).ky < 1 OR sankarit(kuka).kx > max.x OR sankarit(kuka).ky > max.y THEN
    IF worldstyle = world.style.forest OR worldstyle = world.style.grassland THEN
      alarm "Exit area? (Yy[ENTER], Nn[ESC])"
      IF UCASE$(Key$) = "Y" OR Key$ = CHR$(13) THEN 'metsst/ruoholta poistuminen
        CALL save.values
        KILL "map.map"
        RUN "main.bas"
      END IF
    END IF
    sankarit(kuka).kx = sankarit(kuka).x: sankarit(kuka).ky = sankarit(kuka).y
  END IF
  IF onkoeste(sankarit(kuka).kx, sankarit(kuka).ky, 0) THEN
    handle.map.area sankarit(kuka).kx, sankarit(kuka).ky
    sankarit(kuka).kx = sankarit(kuka).x: sankarit(kuka).ky = sankarit(kuka).y
  END IF
  IF sankarit(kuka).x < sankarit(kuka).kx THEN
    xm% = 1
  ELSEIF sankarit(kuka).x > sankarit(kuka).kx THEN
    xm% = -1
  ELSE
    xm% = 0
  END IF
  IF sankarit(kuka).y < sankarit(kuka).ky THEN
    ym% = 1
  ELSEIF sankarit(kuka).y > sankarit(kuka).ky THEN
    ym% = -1
  ELSE
    ym% = 0
  END IF
  IF xm% <> 0 OR ym% <> 0 THEN
    IF onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y + ym%, 0) THEN
      IF xm% <> 0 AND ym% <> 0 THEN
        IF onkoeste(sankarit(kuka).x, sankarit(kuka).y + ym%, 0) THEN
          IF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, 0) THEN
            ym% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, 0) THEN
            xm% = 0 - xm%: ym% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, ym%) THEN
            xm% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, -ym%) THEN
            xm% = 0: ym% = 0 - ym%
          ELSEIF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, -ym%) THEN
            ym% = 0 - ym% 'helppoa
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, ym%) THEN
            xm% = 0 - xm% 'helppoa
          ELSE 'retreat!
            xm% = 0 - xm%: ym% = 0 - ym%
          END IF
        ELSE
          IF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, ym%) THEN
            xm% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, -ym%) THEN
            xm% = 0: ym% = 0 - ym%
          ELSEIF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, 0) THEN
            ym% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, 0) THEN
            xm% = 0 - xm%: ym% = 0
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, ym%) THEN
            xm% = 0 - xm%
          ELSEIF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, -ym%) THEN
            ym% = 0 - ym%
          ELSE 'retreat!
            xm% = 0 - xm%: ym% = 0 - ym%
          END IF
        END IF
      ELSE  'suorille oikaisuille
        IF xm% <> 0 THEN
          IF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y - 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, -1) THEN
            ym% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x + xm%, sankarit(kuka).y + 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(xm%, 1) THEN
            ym% = 1
          ELSEIF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y - 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, -1) THEN
            xm% = 0: ym% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x, sankarit(kuka).y + 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(0, 1) THEN
            xm% = 0: ym% = 1
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y - 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, -1) THEN
            xm% = 0 - xm%: ym% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x - xm%, sankarit(kuka).y + 1, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-xm%, 1) THEN
            xm% = 0 - xm%: ym% = 1
          ELSE
            xm% = 0 - xm%
          END IF
        ELSE  'ym <> 0
          IF NOT onkoeste(sankarit(kuka).x - 1, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-1, ym%) THEN
            xm% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x + 1, sankarit(kuka).y + ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(1, ym%) THEN
            xm% = 1
          ELSEIF NOT onkoeste(sankarit(kuka).x - 1, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-1, 0) THEN
            ym% = 0: xm% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x + 1, sankarit(kuka).y, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(1, 0) THEN
            ym% = 0: xm% = 1
          ELSEIF NOT onkoeste(sankarit(kuka).x - 1, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(-1, -ym%) THEN
            ym% = 0 - ym%: xm% = -1
          ELSEIF NOT onkoeste(sankarit(kuka).x + 1, sankarit(kuka).y - ym%, 0) AND vastasuunta(sankarit(kuka).ls) <> suuntabyxm(1, -ym%) THEN
            ym% = 0 - ym%: xm% = 1
          ELSE
            ym% = 0 - ym%
          END IF
        END IF
      END IF
    END IF
    IF xm% <> 0 OR ym% <> 0 THEN 'liikutaan
      CALL move.hero(kuka, xm%, ym%)
    END IF
  END IF 'if xm<>0 and ym<>0
END SUB

FUNCTION onkoeste% (x AS INTEGER, y AS INTEGER, fly AS INTEGER)
  IF x < 1 OR y < 1 OR x > max.x OR y > max.y THEN
    z% = (1 = 1)
  'laavan & veden ylitys lentmll
  ELSEIF kartta(x, y).yleisobj = obj.este AND (kartta(x, y).erikobj = OBJ.ESTE.VETTA OR kartta(x, y).erikobj = OBJ.ESTE.LAAVAA) AND fly <> 0 THEN
    z% = (1 = 0)
  ELSEIF kartta(x, y).yleisobj = obj.este OR (kartta(x, y).yleisobj = OBJ.OVI AND kartta(x, y).erikobj <> obj.ovi.auki) THEN
    z% = (1 = 1)
  ELSE
    z% = (1 = 0)
  END IF
  onkoeste% = z%
END FUNCTION

'kuka pomii x,y:st
SUB pick.up (kuka AS INTEGER, x AS INTEGER, y AS INTEGER)
  DIM linkit(1 TO 10) AS INTEGER
  IF kartta(x, y).itemlink <> 0 THEN
    'voiko poimia?
    q% = 0
    FOR a% = 1 TO max.item.carry
      IF inventory(kuka, a%, itemtype) = 0 THEN q% = a%: EXIT FOR
    NEXT a%
    IF q% <> 0 THEN
      'monta
      IF esineet(kartta(x, y).itemlink).ketju <> 0 THEN
        LOCATE 1, 14: COLOR 15: PRINT "Pick up what?"
        DO
          CALL mousehide
          LOCATE 3, 1
          q% = 0
          FOR a% = 1 TO max.item.carry
            IF inventory(kuka, a%, itemtype) = 0 THEN q% = a%: EXIT FOR
          NEXT a%
          IF q% = 0 OR esineet(kartta(x, y).itemlink).ketju = 0 THEN
            EXIT DO
          END IF
          maara% = 1: a% = kartta(x, y).itemlink
        DO
          'tulostetaan esineen nimi
          COLOR 15: PRINT "("; maara%; ")";
          linkit(maara%) = a%
          SELECT CASE esineet(a%).tyyppi
            CASE esine.ase: COLOR 12: PRINT aseluokat(esineet(a%).linkki).nimi + "*WEAPON*"
            CASE esine.kirja: PRINT "Book of "; : COLOR 40: PRINT kirjaluokat(esineet(a%).linkki).nimi
            CASE esine.panssari: COLOR 26: PRINT suojaluokat(esineet(a%).linkki).nimi + "*ARMOR *"
            CASE esine.kilpi: COLOR 26: PRINT kilpiluokat(esineet(a%).linkki).nimi + "*SHIELD*"
            CASE esine.kypara: COLOR 26: PRINT kyparaluokat(esineet(a%).linkki).nimi + "* HELM *"
            CASE esine.juoma: COLOR 54: PRINT potions(esineet(a%).linkki).nimi + "*DRINK *"
          END SELECT
          a% = esineet(a%).ketju 'nxt item
          IF a% = 0 OR maara% = 10 THEN EXIT DO'=0 jo ketjun viimeinen, -1 jos palassa ei lainkaan esinett
          maara% = maara% + 1
        LOOP
        FOR a% = maara% + 1 TO 10
          PRINT SPACE$(33)
        NEXT
        LOCATE 14, 3: COLOR 15: PRINT "Chose 1-"; maara%; "or esc to cancel"
        CALL mouseshow: z% = 0
        DO
          Key$ = INKEY$
          IF (VAL(Key$) >= 1 AND VAL(Key$) <= maara%) OR Key$ = CHR$(27) THEN EXIT DO
          CALL mousestatus
          IF mouse.button = 0 AND z% = 1 THEN
            IF mouse.y > 16 AND mouse.y < 16 + maara% * 8 THEN Key$ = STR$(INT((mouse.y - 16) / 8) + 1): EXIT DO
            z% = 0
          END IF
          IF (mouse.button AND 1) AND z% = 0 THEN
            z% = 1
          END IF
        LOOP
        IF Key$ <> CHR$(27) THEN
          w% = VAL(Key$)
          inventory(kuka, q%, itemtype) = esineet(linkit(w%)).tyyppi + 1
          inventory(kuka, q%, itemlink) = esineet(linkit(w%)).linkki
          IF w% = 1 THEN 'edellinen linkki on maanpinnassa.
            kartta(x, y).itemlink = esineet(linkit(1)).ketju
          ELSE
            esineet(linkit(w% - 1)).ketju = esineet(linkit(w%)).ketju
          END IF
          esineet(linkit(w%)).tyyppi = -1 'plt
        END IF
        IF Key$ = CHR$(27) THEN EXIT DO
        LOOP
        CALL mouseshow
      ELSE 'vain yksi
        inventory(kuka, q%, itemtype) = esineet(kartta(x, y).itemlink).tyyppi + 1
        inventory(kuka, q%, itemlink) = esineet(kartta(x, y).itemlink).linkki
        esineet(kartta(x, y).itemlink).tyyppi = -1
        kartta(x, y).itemlink = 0
      END IF
    ELSE
      alarm "Can't pick up: no room."
    END IF
  ELSE
    alarm "Can't pick up: not an item."
  END IF
  Key$ = ""
END SUB

SUB pyyhi.nappain
  DO
    Key$ = ""
    Key$ = INKEY$
    IF Key$ = "" THEN EXIT DO
  LOOP
END SUB

'palautetaan liikkumispisteet vuoron jlkeen
SUB reg.heroes
FOR a% = 1 TO pelaajia
  sankarit(a%).acpoints = sankarit(a%).acpmax
  sankarit(a%).kx = sankarit(a%).x: sankarit(a%).ky = sankarit(a%).y
NEXT
END SUB

SUB round (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
  FOR a% = 0 TO 5
    LINE (x - a%, y - a%)-(x + w + a%, y + h + a%), 16 + (a% * 3), B
  NEXT a%
END SUB

SUB save.map
  OPEN curr.file FOR BINARY AS #1
  PUT #1, 1, worldstyle
  FOR x% = 1 TO max.x
    FOR y% = 1 TO max.y
      PUT #1, , kartta(x%, y%).dat
      PUT #1, , kartta(x%, y%).yleisobj
      PUT #1, , kartta(x%, y%).erikobj
      PUT #1, , kartta(x%, y%).oliolink
      PUT #1, , kartta(x%, y%).itemlink
  NEXT y%, x%
  FOR x% = 1 TO max.items
    PUT #1, , esineet(x%).linkki
    PUT #1, , esineet(x%).tyyppi
    PUT #1, , esineet(x%).ketju
  NEXT x%
  FOR a% = 1 TO MAX.H.TYPE
    PUT #1, , hirvioluokka(a%).nimi
    PUT #1, , hirvioluokka(a%).file
    PUT #1, , hirvioluokka(a%).elomax
    PUT #1, , hirvioluokka(a%).range
    PUT #1, , hirvioluokka(a%).steps
    PUT #1, , hirvioluokka(a%).pase
    PUT #1, , hirvioluokka(a%).spec
  NEXT a%
  PUT #1, , ylos.file
  PUT #1, , alas.file
  FOR a% = 1 TO max.monsters
    PUT #1, , hirviot(a%).tyyppi
    PUT #1, , hirviot(a%).x
    PUT #1, , hirviot(a%).y
    PUT #1, , hirviot(a%).elo
    PUT #1, , hirviot(a%).onoff
    PUT #1, , hirviot(a%).ase
  NEXT a%
  CLOSE #1
  CALL save.values
END SUB

'tallettaa pelin jlkeen sankaridatan
SUB save.values
  OPEN "heroes.dat" FOR BINARY AS #1
  FOR a% = 1 TO MAX.PLAYER
    PUT #1, , sankarit(a%).rotu
    PUT #1, , sankarit(a%).luokka
    PUT #1, , sankarit(a%).acpmax
    PUT #1, , sankarit(a%).nimi
    PUT #1, , sankarit(a%).elo
    PUT #1, , sankarit(a%).elomax
    PUT #1, , sankarit(a%).mana
    PUT #1, , sankarit(a%).manax

    PUT #1, , sankarit(a%).ase
    PUT #1, , sankarit(a%).kypara
    PUT #1, , sankarit(a%).kilpi
    PUT #1, , sankarit(a%).armori
    PUT #1, , sankarit(a%).loitsu
    FOR B% = 1 TO max.item.carry
      PUT #1, , inventory(a%, B%, itemtype)
      PUT #1, , inventory(a%, B%, itemlink)
    NEXT B%
    FOR B% = 1 TO MAX.BOOK
      PUT #1, , loitsut(a%, B%)
    NEXT B%
  NEXT
 
  CLOSE #1
END SUB

SUB see.area (x AS INTEGER, y AS INTEGER, r AS INTEGER)
  kehapisteet% = r * 8
DIM x1 AS INTEGER, y1 AS INTEGER, kp(1 TO kehapisteet%, 2) AS INTEGER
  'lasketaan kehpisteiden koordinaatit
  'yl & alaosa
  w% = 1'mik piste meneilln
  FOR x1 = (x - r) TO (x + r)
    kp(w%, 1) = x1
    kp(w%, 2) = y - r
    IF kp(w%, 1) < 1 THEN kp(w%, 1) = 1
    IF kp(w%, 2) < 1 THEN kp(w%, 2) = 1
    IF kp(w%, 1) > max.x THEN kp(w%, 1) = max.x
    IF kp(w%, 2) > max.y THEN kp(w%, 2) = max.y
    kp(w% + (r * 4), 1) = x1  'alaosa
    kp(w% + (r * 4), 2) = y + r
    IF kp(w% + (r * 4), 1) < 1 THEN kp(w% + (r * 4), 1) = 1
    IF kp(w% + (r * 4), 2) < 1 THEN kp(w% + (r * 4), 2) = 1
    IF kp(w% + (r * 4), 1) > max.x THEN kp(w% + (r * 4), 1) = max.x
    IF kp(w% + (r * 4), 2) > max.y THEN kp(w% + (r * 4), 2) = max.y
    w% = w% + 1
  NEXT x1
  'vasen & oikea
  FOR y1 = (y - r + 1) TO (y + r - 1)
    kp(w%, 1) = x - r
    kp(w%, 2) = y1
    IF kp(w%, 1) < 1 THEN kp(w%, 1) = 1
    IF kp(w%, 2) < 1 THEN kp(w%, 2) = 1
    IF kp(w%, 1) > max.x THEN kp(w%, 1) = max.x
    IF kp(w%, 2) > max.y THEN kp(w%, 2) = max.y
    kp(w% + (r * 4), 1) = x + r'alaosa
    kp(w% + (r * 4), 2) = y1
    IF kp(w% + (r * 4), 1) < 1 THEN kp(w% + (r * 4), 1) = 1
    IF kp(w% + (r * 4), 2) < 1 THEN kp(w% + (r * 4), 2) = 1
    IF kp(w% + (r * 4), 1) > max.x THEN kp(w% + (r * 4), 1) = max.x
    IF kp(w% + (r * 4), 2) > max.y THEN kp(w% + (r * 4), 2) = max.y
    w% = w% + 1
  NEXT y1
w% = 0: q% = 0 'w:saadaanko menn suoraan q:kumpaan ensin (-1=x,0=y)
  FOR a% = 1 TO kehapisteet%
    x1 = x: y1 = y: w% = 0
    q% = ABS(x1 - kp(a%, 1)) > ABS(y1 - kp(a%, 2))
    DO
      IF ABS(x1 - kp(a%, 1)) = ABS(y1 - kp(a%, 2)) THEN w% = (1 = 1)
      IF kartta(x1, y1).dat <> NAKYY THEN
        kartta(x1, y1).dat = NAKYY
      END IF
      IF (kartta(x1, y1).yleisobj = obj.este AND kartta(x1, y1).erikobj = OBJ.ESTE.MUURI) OR (kartta(x1, y1).yleisobj = OBJ.OVI AND kartta(x1, y1).erikobj <> obj.ovi.auki) OR (x1 = kp(a%, 1) AND y1 = kp(a%, 2)) THEN EXIT DO
      IF NOT w% THEN
        IF q% THEN
          IF x1 < kp(a%, 1) THEN
            x1 = x1 + 1
          ELSEIF x1 > kp(a%, 1) THEN
            x1 = x1 - 1
          END IF
        ELSE
          IF y1 < kp(a%, 2) THEN
            y1 = y1 + 1
          ELSEIF y1 > kp(a%, 2) THEN
            y1 = y1 - 1
          END IF
        END IF
      ELSE 'mennn suoraan
          IF x1 < kp(a%, 1) THEN
            x1 = x1 + 1
          ELSEIF x1 > kp(a%, 1) THEN
            x1 = x1 - 1
          END IF
          IF y1 < kp(a%, 2) THEN
            y1 = y1 + 1
          ELSEIF y1 > kp(a%, 2) THEN
            y1 = y1 - 1
          END IF
      END IF
    LOOP
  NEXT a%
END SUB

FUNCTION suuntabyxm% (xm AS INTEGER, ym AS INTEGER)
  IF xm = 0 AND ym = -1 THEN
    y% = 1
  ELSEIF xm = 1 AND ym = 1 THEN
    y% = 2
  ELSEIF xm = 1 AND ym = 0 THEN
    y% = 3
  ELSEIF xm = 1 AND ym = 1 THEN
    y% = 4
  ELSEIF xm = 0 AND ym = 1 THEN
    y% = 5
  ELSEIF xm = -1 AND ym = 1 THEN
    y% = 6
  ELSEIF xm = -1 AND ym = 0 THEN
    y% = 7
  ELSEIF xm = -1 AND ym = -1 THEN
    y% = 8
  ELSE
    y% = -1
  END IF
  suuntabyxm% = y%
END FUNCTION

SUB upgr.panel
  FOR a% = 1 TO 40
    IF a% <= sankarit(LEADER).acpoints THEN
      c% = 12
    ELSEIF a% <= sankarit(LEADER).acpmax THEN
      c% = 18
    ELSE
      c% = 26
    END IF
    LINE (120 + (a% - 1) * 3, 162)-(121 + (a% - 1) * 3, 163), c%
  NEXT
  LINE (120 + INT((120 / sankarit(LEADER).elomax) * sankarit(LEADER).elo), 165)-(240, 166), 26, BF
  LINE (120 + INT((120 / sankarit(LEADER).manax) * sankarit(LEADER).mana), 168)-(240, 169), 26, BF
  LINE (120, 165)-(120 + INT((120 / sankarit(LEADER).elomax) * sankarit(LEADER).elo), 166), 70, BF
  LINE (120, 168)-(120 + INT((120 / sankarit(LEADER).manax) * sankarit(LEADER).mana), 169), 40, BF
END SUB

FUNCTION vastasuunta% (s AS INTEGER)
  IF s < 0 THEN 'mrittelemtn
    y% = -1
  ELSEIF s > 4 THEN
    y% = s - 4
  ELSE
    y% = s + 4
  END IF
  vastasuunta% = y%
END FUNCTION

